unit FileNameUnit;

interface

Uses Windows,SysUtils,Forms,FileUtil;

function GetLoadFileName(oldName,newExt:String):String;
function GetNewFileName(oldName,newExt:String):String;
function GetOChartFName(oldName,newExt:String):String;

implementation

function GetNewFileName(oldName,newExt:String):String;
Var s,s1,s2:String;
begin
 s:=ExtractFilePath(oldName);
 s1:=ExtractFileName(oldName);
 s2:=ExtractFileExt(oldName);
 Result:=s+copy(s1,1,length(s1)-length(s2))+'.'+newExt;
 if not(FileExists(Result)) then
   begin
    CopyFile(ExtractFilePath(Application.ExeName)+'new.'+newExt,Result,nil);
   end;
end;

function GetLoadFileName(oldName,newExt:String):String;
Var s,s1,s2:String;
begin
 s:=ExtractFilePath(oldName);
 s1:=ExtractFileName(oldName);
 s2:=ExtractFileExt(oldName);
 Result:=s+copy(s1,1,length(s1)-length(s2))+'.'+newExt;
 if not(FileExists(Result))
  then
   begin
    CopyFile(ExtractFilePath(Application.ExeName)+'new.'+newExt,Result,nil);
   end;
end;

function GetOChartFName(oldName,newExt:String):String;
begin
 Result:=ExtractFilePath(Application.ExeName)+'temp.'+newExt;
 if not(FileExists(Result)) then Result:=ExtractFilePath(Application.ExeName)+'new.'+newExt;
 if (length(oldName)>0) then Result:=GetNewFileName(oldName,newExt);
end;

end.
