unit PrepUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, TFlatProgressBarUnit;

type
  TPrepareForm = class(TForm)
    AbortButton: TButton;
    ProgressBar: TFlatProgressBar;
    ProcLabel: TLabel;
    Label1: TLabel;
    LoadTimer: TTimer;
    procedure AbortButtonClick(Sender: TObject);
    procedure LoadTimerTimer(Sender: TObject);
  private
    { Private declarations }
    FCount:Integer;
  public
    { Public declarations }
    property Count:Integer Read FCount write FCount;
  end;

var
  PrepareForm: TPrepareForm;

implementation

uses MainUnit;

{$R *.DFM}

procedure TPrepareForm.AbortButtonClick(Sender: TObject);
begin
  BPViewMainForm.AbortDoc:=True;
  BPViewMainForm.BPFrame.Aborting:=True;
  BPViewMainForm.BPDfdFrame.Aborting:=True;
  BPViewMainForm.BPLSAFrame.Aborting:=True;
  BPViewMainForm.BPNEWDFDFrame.Aborting:=True;
{  BPViewMainForm.BPMSDFrame.Aborting:=True;}
end;

procedure TPrepareForm.LoadTimerTimer(Sender: TObject);
begin
  ProgressBar.Position:=FCount mod 100;
  ProgressBar.Invalidate;
  ProcLabel.Caption:=IntToStr(FCount mod 100);
  ProcLabel.Invalidate;
  Application.ProcessMessages;
end;

end.
