unit ColonTitleDlgUnit;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs, ExtDlgs, Spin,Printers;

type
  TColonTitleDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Bevel1: TBevel;
    Button1: TButton;
    FontDialog: TFontDialog;
    Bevel2: TBevel;
    LogoLeft: TSpinEdit;
    LogoTop: TSpinEdit;
    OpenPictureDialog: TOpenPictureDialog;
    Label4: TLabel;
    Label7: TLabel;
    BitBtn1: TBitBtn;
    useLogo: TCheckBox;
    Bevel3: TBevel;
    LeftLine: TCheckBox;
    RightLine: TCheckBox;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure useLogoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     FLogoLoaded:Boolean;
  end;

var
  ColonTitleDlg: TColonTitleDlg;

implementation

uses MasterOFormUnit;

{$R *.DFM}

procedure TColonTitleDlg.Button1Click(Sender: TObject);
begin
  FontDialog.Execute;
end;

procedure TColonTitleDlg.BitBtn1Click(Sender: TObject);
var x,y:Integer;
    pixx,pixy:Integer;
const inch:Double=25.4;
begin
  if OpenPictureDialog.Execute then
   begin
    FLogoLoaded:=True;
    MasterForm.RichPrinter1.BitmapLogo.LoadFromFile(OpenPictureDialog.FileName);
    LogoLeft.Value:=Round(MasterForm.RichPrinter1.LogoLeft);
    LogoTop.Value:=Round(MasterForm.RichPrinter1.LogoTop);
    x:=GetDeviceCaps(Printer.Handle,LOGPIXELSX); { pix_x/inch }
    y:=GetDeviceCaps(Printer.Handle,LOGPIXELSY);{ pix_y/inch }
    pixx:=MasterForm.RichPrinter1.BitmapLogo.Width;
    pixy:=MasterForm.RichPrinter1.BitmapLogo.Height;
    MasterForm.RichPrinter1.LogoWidth:=(pixx*inch)/x;
    MasterForm.RichPrinter1.LogoHeight:=(pixy*inch)/y;
    LogoLeft.Enabled:=FLogoLoaded;
    LogoTop.Enabled:=FLogoLoaded;
    UseLogo.Checked:=True;
   end;
end;

procedure TColonTitleDlg.useLogoClick(Sender: TObject);
begin
  if useLogo.Checked=False then
    begin
      LogoLeft.Enabled:=False;
      LogoTop.Enabled:=False;
      FLogoLoaded:=False;
      if not(MasterForm.RichPrinter1.BitmapLogo.Empty) then
      begin
       if MasterForm.RichPrinter1.BitmapLogo.Palette<>0 then
       begin
       DeleteObject(HPalette(MasterForm.RichPrinter1.BitmapLogo.Palette));
       MasterForm.RichPrinter1.BitmapLogo.Palette:=0;
       end;
       if MasterForm.RichPrinter1.BitmapLogo.Handle<>0 then
       begin
       DeleteObject(HBitmap(MasterForm.RichPrinter1.BitmapLogo.Handle));
       MasterForm.RichPrinter1.BitmapLogo.Handle:=0;
       MasterForm.RichPrinter1.LogoWidth:=0;
       MasterForm.RichPrinter1.LogoHeight:=0;
       end;
      end;
    end;
   if useLogo.Checked and MasterForm.RichPrinter1.BitmapLogo.Empty then
      useLogo.Checked:=False;
end;

end.
