unit DebugUnit;

interface

Uses Windows,SysUtils,Classes,Forms;


Type TErrorRecord=Record
      DateTime:TDateTime;
      EncryptProc:ShortString;
      EncryptClass:ShortString;
      EncryptMessage:ShortString;
     end;

Const LogName='mastero.log';


procedure WriteLog(proc:String;Exc:Exception);
function  EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
function  EncryptString(s:String):String;

implementation

function  EncryptString(s:String):String;
Var i:Integer;
begin
 Result:=s;
 for i:=1 to Length(Result) do
  Result[i]:=Chr(Byte(Result[i]) xor $55);
end;

procedure WriteLog(proc:String;Exc:Exception);
Var {f:TextFile;}
    f:File of TErrorRecord;
    rec:TErrorRecord;
begin
{}
 try
 AssignFile(f,ExtractFilePath(Application.ExeName)+LogName);
  {$I-}
   Reset(f);
   if IOResult<>0 then rewrite(f);
  {$I+}
   while not(eof(f)) do read(f,rec);
   rec.DateTime:=Now;
   rec.EncryptProc:=EncryptString(proc);
   rec.EncryptClass:=EncryptString(Exc.ClassName);
   rec.EncryptMessage:=EncryptString(Exc.Message);
   write(f,rec);
   CloseFile(f);
 except
  { raise Exception.Create('Unable to write Bug Report File');}
 end;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
 try
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
 except
  on E:Exception do
   begin
    WriteLog('AFSetupForm:EnumFontsProc',E);
    Result:=0;
   end;
 end;
end;


end.
