{*******************************************************}
{                                                       }
{         Delphi VCL Extensions (RX)                    }
{                                                       }
{         Copyright (c) 1995, 1996 AO ROSNO             }
{         Copyright (c) 1997 Master-Bank                }
{                                                       }
{*******************************************************}

unit RXConst;

interface

{$I RX.INC}

uses Controls;

const
  RX_VERSION = $00020020;  { 2.32 }

const
{ Command message for Speedbar editor }
  CM_SPEEDBARCHANGED = CM_BASE + 60;
{ Command message for TRxSpeedButton }
  CM_RXBUTTONPRESSED = CM_BASE + 61;
{ Command messages for TRxWindowHook }
  CM_RECREATEWINDOW  = CM_BASE + 62;
  CM_DESTROYHOOK     = CM_BASE + 63;
{$IFDEF WIN32}
{ Notify message for TrayIcon }
  CM_TRAYICON        = CM_BASE + 64;
{$ENDIF}

const
  crHand     = 14000;
  crDragHand = 14001;

const
{ TBitmap.GetTransparentColor from GRAPHICS.PAS use this value }
  TransparentMask = $02000000;

{$IFDEF VER100}
const
  SDelphiKey = 'Software\Borland\Delphi\3.0';
{$ENDIF}

{$IFDEF VER90}
const
  SDelphiKey = 'Software\Borland\Delphi\2.0';
{$ENDIF}

{$IFDEF VER93}
const
  SDelphiKey = 'Software\Borland\C++Builder\1.0';
{$ENDIF}

implementation

end.