unit NClass;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls,  ComCtrls, FileCtrl,Utils,FileUtil,
  Mask, ToolEdit,Dialogs, ImgList;

type
  TNewClass = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    CList: TListView;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    PrjName: TEdit;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    Label8: TLabel;
    Avtor: TEdit;
    Prim: TMemo;
    NLabel: TLabel;
    ObjectNumber: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure CListClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ObjectNumberKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  NewClass: TNewClass;

implementation

uses MAIN,  StrTab, appConst, items, Umessages;

{$R *.DFM}

procedure TNewClass.FormActivate(Sender: TObject);
 var R:TSearchRec;
     Found:Integer;
     NewItem:TListItem;
     Path,mask:String;

begin
ObjectNumber.text:='';
PrjName.text:='';
//FNames:=TStrings.Create;
Path:=appconst.sysinfo.libraryPath[0];
Mask:='*.spr';
Found:=FindFirst(Path+Mask,faAnyFile,R);
CList.Items.Clear;
 while Found = 0 do
  begin
  NewItem:=Clist.Items.Add;
  NewItem.ImageIndex:=0;
  NewItem.Caption:=CutFileExt(R.Name);
  Found:=FindNext(R);
  end;

end;

procedure TNewClass.CListClick(Sender: TObject);
begin
If CList.Selected= nil then
 begin
 OkBtn.Enabled:=false;
 exit;
 end else OkBtn.Enabled:=true;
 
 PrjName.Text:=CList.Selected.Caption;
end;

procedure TNewClass.OKBtnClick(Sender: TObject);
var mask:word;
    c:TOMItems;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if PrjName.Text='' then
begin
MessageDlg(Umessages.enterthename,mtError,[mbOk],0);
exit;
end;

if CList.Selected=nil then
begin
MessageDlg(umessages.sprnotselect, mtError, [mbOK], 0);
exit;
end;

setcurrentdir(appconst.sysinfo.datadir);
STRTables.modelT.Append;
STRTables.modelT.FieldByName('Name').asString:=ClearSpaces(ObjectNumber.text+' '+PrjNAme.Text);
STRTables.modelT.FieldByName('Type').asInteger:=SPRID;
STRTables.MODELTMDate.asDateTime:=now;
STRTables.MODELTSp2.asInteger:=trunc(now);
STRTables.MODELTSp1.asInteger:=0;

STRTables.modelT.FieldByName('Mdate').AsDateTime:=now;
STRTables.modelT.FieldByName('Avtor').AsString:=Avtor.Text;
STRTables.modelT.FieldByName('Comm').AsString:=Prim.Text;
STRTables.modelT.Post;
c:=TOMItems.Create;
try
c.diriD:=STRTables.ModelTN.AsInteger;
c.caption:=PrjName.Text;
c.ComTitle:='';
c.LoadFromFile(appconst.sysinfo.librarypath[0] + CList.Selected.Caption+'.spr');
STRTables.Save_Spr(c.diriD,c,OrgMasterMain.PB);
finally
c.free;
end;
OrgMasterMain.appendnewmodelitem;
STRTables.spr.refresh;
{$ENDIF}
{$ENDIF}
modalResult:=mrOk;
end;

procedure TNewClass.FormCreate(Sender: TObject);
begin
{$IFDEF PLANNER}
{$ELSE}
 ScaleTypeSel.visible:=false;

{$ENDIF}
Avtor.text:=appconst.sysinfo.defavtor;
end;

procedure TNewClass.ObjectNumberKeyPress(Sender: TObject; var Key: Char);
begin
if not (key in [#8,'0'..'9','.']) then Key:=#0;  
end;

end.
