unit NewPr;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Db, DBTables, RXLookup, Mask, DBCtrls, ToolEdit,
  checklst, ComCtrls, Grids, Items, Dialogs, Menus,dcommon;

type
  pinteger=^integer;
  TNewPro = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label5: TLabel;
    Comm: TLabel;
    NLabel: TLabel;
    Edit1: TEdit;
    avtor: TEdit;
    Prim: TMemo;
    ObjectNumber: TEdit;
    GroupBox1: TGroupBox;
    Spr1: TComboBox;
    Spr2: TComboBox;
    LinksNames: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    IndexPage: TTabSheet;
    Label6: TLabel;
    Panel1: TPanel;
    IOName: TEdit;
    outName: TEdit;
    inName: TEdit;
    Label9: TLabel;
    Label8: TLabel;
    Label7: TLabel;
    Panel2: TPanel;
    Label11: TLabel;
    Label12: TLabel;
    Downgrade: TCheckBox;
    Protype: TComboBox;
    ABCList: TComboBox;
    DoEnableMirror: TCheckBox;
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Spr1Click(Sender: TObject);
    procedure ObjectNumberKeyPress(Sender: TObject; var Key: Char);
    procedure FormDestroy(Sender: TObject);
    procedure ProtypeClick(Sender: TObject);
  private
    { Private declarations }
    l:TLiteLinks;
  public
    { Public declarations }
    function ShowModal(ClsLeft,ClsRight,clsMiddle:PModelObject):integer;
  end;

var
  NewPro: TNewPro;

implementation
Uses Main,appconst,  StrTab,  Umessages, utils;

{$R *.DFM}




procedure TNewPro.OKBtnClick(Sender: TObject);
var Sp2N,mask:Integer;
    newmo:PModelObject;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if edit1.text='' then
begin
  MessageDlg(umessages.enterthename,
  mtError,[mbOk], 0);
exit;
end;
if (spr1.ItemIndex=-1) or (spr2.ItemIndex=-1) then
begin
MessageDlg(umessages.setsprwarning,mtError,[mbOk],0);
if (spr1.ItemIndex=-1) then activecontrol:=spr1
                               else activecontrol:=spr2;
exit;
end;
Sp2N:=PModelObject(Spr2.Items.Objects[spr2.itemindex])^.n;
with strtables do
begin
modelT.Append;
mask:=0;
modelT.FieldByName('Name').AsString:=ClearSpaces(Objectnumber.text+' '+Edit1.Text);
modelT.FieldByName('Type').AsInteger:=PROID;
modelT.FieldByName('Sp1').AsInteger:=PModelObject(Spr1.Items.Objects[spr1.itemindex])^.n;
modelT.FieldByName('Sp2').AsInteger:=Sp2N;
modelT.FieldByName('Comm').AsString:=Prim.Text;
modelT.FieldByName('Avtor').AsString:=Avtor.Text;
ModelTMDate.asDateTime:=Now;
STRTables.modelT.FieldByName('Mdate').AsDateTime:=Now;
if linksnames.ItemIndex>0 then
 modelTSPRType.AsInteger:=PModelObject(linksnames.items.Objects[linksnames.ItemIndex])^.n
else
 modelTSPRType.AsInteger:=0;
if ABCList.ItemIndex>0 then
ModelTIdxN.AsInteger:=PModelObject(abclist.items.objects[abclist.itemindex])^.n
else
ModelTIdxN.AsInteger:=0;
l.DirMap[1]:=InName.text;
l.DirMap[2]:=OutName.text;
l.dirMap[3]:=IOName.text;
l.dirMap[4]:=IOName.text;
 case  protype.ItemIndex of
0: l.prjType:=ptLRN;
1: l.prjType:=ptIOC;
2: l.prjType:=ptIOM;
3: l.prjType:=ptM;
4: l.prjType:=ptC;
end;
l.doDetail:=downgrade.Checked;
l.MirrorEnabled:=DoEnableMirror.Checked;
l.saveToBLOB(modelTMBData);
modelT.Post;
end;
STRTables.ModelT.Refresh;
newmo:=OrgMasterMain.appendnewmodelitem;
STRTables.updateHistory(STRTables.ModelTN.AsInteger,'');
{$ENDIF}
{$ENDIF}
modalresult:=mrOk;
end;

procedure TNewPro.FormCreate(Sender: TObject);
begin
{$IFNDEF BUSINESS_PROCESS}
{$ENDIF}
avtor.text:=appconst.sysinfo.defavtor;
l:=TLiteLinks.create(nil);
end;

procedure TNewPro.Spr1Click(Sender: TObject);
var s1,s2,s3:string;
begin
if spr1.itemindex<>-1 then
 s1:=Spr1.items[spr1.itemindex]
 else
 s1:='';
if spr2.itemindex<>-1 then
 s2:=Spr2.items[spr2.itemindex]
 else
 s2:='';
if linksnames.itemindex<>-1 then
 s3:=linksnames.items[linksnames.itemindex]
 else
 s3:='';
Edit1.text:=utils.cutnumbers(s1)+'_'+utils.cutnumbers(s2);
if s3<>'' then Edit1.text:=Edit1.text+'('+utils.cutnumbers(s3)+')';
end;

procedure TNewPro.ObjectNumberKeyPress(Sender: TObject; var Key: Char);
begin
if not (key in [#8,'0'..'9','.']) then Key:=#0;
end;

procedure TNewPro.FormDestroy(Sender: TObject);
begin
l.free;
end;
function TNewPro.ShowModal(ClsLeft,ClsRight,clsMiddle:PModelObject):integer;
var i:integer;
begin
Prim.Text:='';
Edit1.text:='';
Spr1.clear;
spr2.clear;
linksnames.Clear;
linksnames.items.add('');
Pagecontrol1.activepage:=Tabsheet1;
for i:=0 to OrgMasterMain.sprList.items.count-1 do
 begin
  spr1.items.AddObject(OrgMasterMain.sprList.items[i].caption, OrgMasterMain.sprList.items[i].data);
  spr2.items.AddObject(OrgMasterMain.sprList.items[i].caption,OrgMasterMain.sprList.items[i].data);
  linksnames.Items.AddObject(OrgMasterMain.sprlist.items[i].caption,OrgMasterMain.sprlist.items[i].data);
 end;
//--linksnamesfilling
if clsLeft<>nil then
 spr1.ItemIndex:=spr1.Items.IndexOfObject(TObject(clsLeft));
if clsRight<>nil then
 spr2.ItemIndex:=spr2.Items.IndexOfObject(TObject(clsRight));
if clsMiddle<>nil then
 linksnames.ItemIndex:=linksnames.Items.IndexOfObject(TObject(clsMiddle));

l.clear;
inName.font.charset:=204;
OutName.font.charset:=204;
IOName.font.charset:=204;
ABCList.font.charset:=204;
inName.text:=l.dirmap[1];
outName.text:=l.dirmap[2];
ioName.text:=l.dirmap[3];
OrgMasterMain.modelcontense.fillType(appconst.SPRID,ABCList.Items);
downgrade.Checked:=true;
protype.ItemIndex:=0;
spr1.OnClick(spr1);
result:=inherited showmodal;
end;
procedure TNewPro.ProtypeClick(Sender: TObject);
begin
inName.Enabled:=ProType.ItemIndex=0;
outName.Enabled:=ProType.ItemIndex=0;
IOName.Enabled:=ProType.ItemIndex=0;
case ProType.ItemIndex of
0:;
1:begin
      inName.Text:='';
      outName.Text:='';
      IOName.Text:='';
      end;
2:begin
      inName.Text:='';
      outName.Text:='';
      IOName.Text:='';
      end;
3:begin
      inName.Text:='';
      outName.Text:='';
      IOName.Text:='';
      end;
4:begin
      inName.Text:='';
      OutName.Text:='';
      IOName.Text:='';
      end;
end;

end;

end.
