program OMlite;
{$INCLUDE Compmode.inc}

uses
  ShareMem,
  Controls,
  Forms,
  SysUtils,
  Windows,
  Graphics,
  classes,
  dateutil,
  Registry,
  dbtables,
  inifiles,
  menus,
  ActiveX,
  Ole2,
  dialogs,
  MAIN in 'MAIN.pas' {OrgMasterMain},
  pr in 'pr.pas' {Prop},
  TreeOps in 'TreeOps.pas',
  opt in 'opt.pas' {options},
  EComps in 'EComps.pas' {EdtComps},
  NewPrItm in 'NewPrItm.pas' {NewCompItemLT},
  EdtPrItmLT in 'EdtPrItmLT.pas' {EdtCompItem},
  NewPr in 'NewPr.pas' {NewPro},
  prnprv in 'prnprv.pas' {PrintPreview},
  multip in 'multip.pas' {RepWZD},
  About in 'About.pas' {AboutBox},
  Opdlds in 'Opdlds.pas' {OpDlg},
  edtops in 'edtops.pas',
  PProp in 'PProp.pas' {ProProp},
  PackT in 'PackT.pas',
  Finds in 'Finds.pas',
  zastform in 'zastform.pas' {Zast},
  newwzd in 'newwzd.pas' {OpenWzd},
  newpdot in 'newpdot.pas' {NewFromDOT},
  NC in 'NC.pas' {NewComps},
  NClass in 'NClass.pas' {NewClass},
  supp in 'supp.pas' {Support},
  StrTab in 'StrTab.pas' {STRTables: TDataModule},
  appconst in 'appconst.pas',
  lnkpropF in 'lnkpropF.pas' {LinkProp},
  rptprop in 'rptprop.pas' {RepProp},
  F25 in 'F25.pas',
  compops in 'compops.pas',
  Prnsel in 'Prnsel.pas' {PrintMarkSel},
  Prnprsel in 'Prnprsel.pas' {PrintProSel},
  Findunit in 'Findunit.pas' {Find},
  findunit2 in 'findunit2.pas' {Replace},
  dcommon in 'dcommon.pas',
  SprP in 'SprP.pas' {sprProp},
  GV in 'GV.pas' {GraphForm},
  RepTypes in 'RepTypes.pas',
  rdiag in 'rdiag.pas' {RowDiagram},
  styledef in 'styledef.pas',
  stylestr in 'stylestr.pas',
  Utils in 'Utils.pas',
  Items in 'Items.pas',
  itUtils in 'itUtils.pas',
  logs in 'logs.pas',
  MatrixProjection in 'MatrixProjection.pas',
  myLists in 'myLists.pas',
  Umessages in 'Umessages.pas',
  ColoredGrid in 'ColoredGrid.pas',
  txthtml in 'txthtml.pas',
  BitEdit in 'BitEdit.pas',
  bpfpcreateform in 'bpfpcreateform.pas' {BPFromProForm},
  debug in 'debug.pas',
  Bpint in 'Bpint.pas',
  bprename in 'bprename.pas',
  Bpstream in 'Bpstream.pas',
  bpdef in 'bpdef.pas',
  bpfpp in 'bpfpp.pas' {BPFromProProp},
  bpvProp in 'bpvProp.pas' {BPViewProp},
  ExtDlgs in '..\GLOBAL\Delphi\ExtDlgs.pas',
  ExcelRpt in 'ExcelRpt.pas',
  ExcelTemplateReport in 'ExcelTemplateReport.pas',
  ExcelBands in 'ExcelBands.pas',
  mylisttypes in 'mylisttypes.pas',
  xlserrors in 'xlserrors.pas' {ExcelErrors},
  prnmatsel in 'prnmatsel.pas' {PrintMatSel},
  XLSPrepare in 'XLSPrepare.pas',
  otherLists in 'otherLists.pas',
  MSelect in 'MSelect.pas' {MultiSelector},
  clsGrp in 'clsGrp.pas' {ClsGroupSelect},
  TVSelect in 'TVSelect.pas' {TreeSelector},
  otherlisttypes in 'otherlisttypes.pas',
  CombSelector in 'CombSelector.pas' {ListQuery},
  Excel_TLB in 'Excel_TLB.pas',
  StyleFormUnit in 'StyleFormUnit.pas' {StyleForm},
  Shname in 'Shname.pas' {ShablCreate},
  itXML in 'itXML.pas';

procedure generateInfo(l:Tstrings;f:TComponent);
var i:integer;
    s:string;
begin
l.add('<< '+f.name+' >>'+inttostr(f.componentcount));
 for i:=0 to f.ComponentCount-1 do
 begin
 s:=inttostr(i)+':'+f.Components[i].name+'::'+f.Components[i].className;
 if f.components[i] is tcontrol then begin
                 //s:=s+'|c|'+TControl(f.components[i]).caption;
                 s:=s+'%'+TControl(f.components[i]).hint;
                 end;
 if f.components[i] is tmenuitem then begin
                 s:=s+'|m|'+Tmenuitem(f.components[i]).caption;
                 s:=s+'%'+Tmenuitem(f.components[i]).hint;
                 if  assigned(Tmenuitem(f.components[i]).onclick) then
                 s:=s+' OnClick: '+f.methodname(@Tmenuitem(f.components[i]).onclick)
                 else s:=s+' no method assigned';
                 end;

 l.add(s);
 end;
l.add('----------------------------');
end;
{$R *.res}
var
    cns,i,j:integer;
    bigRG:TRegistry;
    BigINI:TMemIniFile;
    Winsysdir,haspcrackname:string;
    config:string;
    p:pointer;
    finfo:Tstrings;
    atom:word;
begin
appconst.version:='3.7.246.1236';
appconst.sysinfo:=TSystemInfo.Create;
try
appconst.sysinfo.sysdir:=extractfilepath(application.exename);
appconst.sysinfo.datadir:=appconst.sysinfo.sysdir;
atom:=GlobalFindAtom(PChar('ORG_MASTER_IS_RUNNING:'+appconst.sysinfo.sysdir));
if atom<>0 then
begin
if messagedlg(umessages.StartAnother,mtWarning,[mbYes,mbNo],0)<>MrYes then
exit;
end
else
atom:=GlobalAddAtom(PChar('ORG_MASTER_IS_RUNNING:'+appconst.sysinfo.sysdir));
try
try
getmem(p,12000000);
except
messagedlg(Umessages.startMemoryCheck,mtError,[mbOK],0);
halt(1);
end;
freemem(p,12000000);
shortdateformat:='dd'+dateseparator+'mm'+dateseparator+'yyyy';
dateutil.FourDigitYear:=true;
dbtables.session.NetFileDir:=appconst.sysinfo.sysdir+'Sys';

setcurrentDir(appconst.sysinfo.sysdir);
logs.MainLog:=TProgramLog.Create('user.$$$');
try
appconst.sysinfo.programlog:=logs.mainlog;
logs.MainLog.Setdebug(50);
logs.MainLog.startlog;
logs.startproc('SYS','DBTABLES','NETDIR',dbtables.session.NetFileDir,5);
Application.OnException:=TOrgMasterMain.Appexception;
Application.OnActivate:=TOrgMasterMain.AppActivate;
BigRg:=Tregistry.Create;
bigINI:=TMemInifile.create(appconst.sysinfo.datadir+'\org_lite.ini');
BigRG.RootKey:=HKEY_LOCAL_MACHINE;
BigRg.OpenKeyReadOnly('SOFTWARE\'+regkey);
if BigRg.ValueExists('debug') then logs.Mainlog.Setdebug(BigRg.ReadInteger('debug'))
                              else logs.MainLog.Setdebug(1);// for test
if BigRg.ValueExists('IPMode') then bpstream.ipmode:=BigRg.ReadInteger('ipmode')
                              else bpstream.ipmode:=0;
{$IFNDEF VIEW}
{$IFNDEF ED}
{$ELSE}
 appconst.sysinfo.permissionsXML:='';
{$ENDIF}
{$ELSE}
 appconst.sysinfo.permissionsXML:='';
{$ENDIF}
{$IFNDEF DEMO}
{$IFNDEF ED}
//HLTime.CheckDate(6811,'1234ABCD','1234567812345678');
if BigRG.valueExists(appconst.sysinfo.datadir+'_SNUMBER') then
 appconst.sysinfo.Serial:=BigRg.ReadString(appconst.sysinfo.datadir+'_SNumber')
 else
 appconst.sysinfo.Serial:='UNREGISTERED';
{$ELSE}
appconst.sysinfo.Serial:=' ';
{$ENDIF}
{$ELSE}
appconst.sysinfo.Serial:=' ';
{$ENDIF}
if BigRG.valueExists(appconst.sysinfo.datadir+'_Company') then
 appconst.sysinfo.Company:=BigRg.ReadString(appconst.sysinfo.datadir+'_Company')
 else
 appconst.sysinfo.company:='';
if BigRG.valueExists(appconst.sysinfo.datadir+'_Name') then
 appconst.sysinfo.defavtor:=BigRG.ReadString(appconst.sysinfo.datadir+'_Name')
 else
 appconst.sysinfo.defavtor:='';
if BigRG.valueExists(appconst.sysinfo.datadir+'_USERID') then
 appconst.sysinfo.defaultversion:=BigRg.ReadInteger(appconst.sysinfo.datadir+'_USERID')
 else
 appconst.sysinfo.defaultversion:=0;

 appconst.sysinfo.dotpath:=appconst.sysinfo.sysdir+'DOTS\';
 appconst.sysinfo.sampath:=appconst.sysinfo.sysdir+'SAMPLES\';
LAstFolder:=BigINI.ReadInteger('Models','_LastFolder',0);
LAstvar:=BigINI.ReadInteger('Models','_LastVar',0);
if BigRG.valueExists('ARCHIVE') then
 sysinfo.archivedir:=BigRG.ReadString('ARCHIVE')
 else
sysinfo.archivedir:=appconst.sysinfo.sysdir+'\';
logs.startproc('STRUCT','Archive','',sysinfo.archivedir,5);
sysinfo.archiveDir:=ANSIUpperCase(sysinfo.archiveDir);
if BigRG.valueExists('LOCALBASE') then
 sysinfo.LocalDataDir:=BigRG.ReadString('LOCALBASE')+'\'
 else
sysinfo.LocalDataDir:=appconst.sysinfo.sysdir+'DATA\';
if BigRG.valueExists('NETASKMODE') then
 sysinfo.AskNetEdit:=BigRG.ReadInteger('NETASKMODE')<>0
  else
 sysinfo.AskNetEdit:=true;

logs.startproc('STRUCT','LocalBase','',sysinfo.LocalDataDir,5);
sysinfo.LocalDataDir:=ANSIUpperCase(sysinfo.LocalDataDir);
if BigRG.ValueExists('CACHED') then
appconst.sysinfo.cache_enabled:=bigRG.ReadInteger('CACHED')=1
else
appconst.sysinfo.cache_enabled:=true;
logs.startproc('STRUCT','Cached','',utils.Boolean10[appconst.sysinfo.cache_enabled],5);
//appconst.cache_Enabled:=false; //*********************************************

if BigRG.ValueExists('LinkedSIZE') then
appconst.sysinfo.maxLinkedCount:=bigRG.ReadInteger('LinkedSIZE')
else
appconst.sysinfo.maxLinkedCount:=500;
logs.startproc('STRUCT','LinkedSize','',inttostr(appconst.sysinfo.maxLinkedCount),5);
if BigRG.ValueExists('UpdateDelay') then
appconst.sysinfo.updateInterval:=bigRG.ReadInteger('UpdateDelay')
else
appconst.sysinfo.updateInterval:=200;
logs.startproc('STRUCT','UpDateDelay','',inttostr(appconst.sysinfo.updateInterval),5);
if BigRG.valueExists('HTMLRoot') then
 sysinfo.publicationDir:=BigRG.ReadString('HTMLRoot')
 else
sysinfo.publicationDir:=appconst.sysinfo.sysdir+'\HTML';
logs.startproc('STRUCT','HTMLRoot','',(appconst.sysinfo.publicationDir),5);
if bigrg.valueexists('LIBRARY') then
 appconst.sysinfo.librarypath[0]:=bigrg.ReadString('LIBRARY')
else
 appconst.sysinfo.librarypath[0]:='LIBRARY\';
appconst.sysinfo.libraryPath[0]:=expandfilename(appconst.sysinfo.libraryPath[0]);
j:=0;
for I:=length(appconst.sysinfo.libraryPath[0]) downto 1 do
 if appconst.sysinfo.libraryPath[0][i]='\' then inc(j)
 else break;
appconst.sysinfo.libraryPath[0]:=system.copy(appconst.sysinfo.libraryPath[0],1,i)+'\';
logs.startproc('STRUCT','LIBRARY','',(appconst.sysinfo.Librarypath[0]),5);

if BigRG.valueExists('FontName') then
 sysinfo.defaultFontName:=BigRG.ReadString('FontName')
 else
sysinfo.defaultFontName:='Arial';
logs.startproc('STRUCT','FontName','',(appconst.sysinfo.defaultFontName),5);
if BIGRG.valueExists('LOGINSERVER') then
 appconst.RegisterServer:=BigRG.ReadString('LOGINSERVER')
 else
 appconst.RegisterServer:='';
appconst.lastTimeExecuted:=BigINI.ReadString('Session','Last visited',' ');
BigRG.CloseKey;
appconst.sysinfo.fontsize:=BigINI.ReadInteger('Options','FontSize',10);
BigRG.openkeyreadonly('SOFTWARE\'+appconst.regkey+'\INFO\');
 if BigRG.valueexists(appconst.sysinfo.datadir+'_AppName') then
appconst.applicationname:=BigRG.readString(appconst.sysinfo.datadir+'_AppName');
BigRG.closekey;
{$IFDEF VIEW}
appconst.applicationname:=appconst.applicationname+'[ ]';
{$ENDIF}
logs.startproc('STRUCT','Application','',appconst.applicationname,5);
appconst.sysinfo.folders.AFMFolder:=appconst.sysinfo.datadir+'DOTS';
appconst.sysinfo.folders.IMGFolder:=appconst.sysinfo.datadir+'TPics';
appconst.sysinfo.folders.TextFolder:=appconst.sysinfo.datadir+'Text';
appconst.sysinfo.folders.ModelFolder:=appconst.sysinfo.LocalDataDir;
appconst.sysinfo.folders.ClsFolder:=appconst.sysinfo.librarypath[0];
with Application do begin
 HelpFile :={sysdir+}'HELP\Struct.hlp';
 Title:=appconst.applicationname;
end;
setcurrentdir(appconst.sysinfo.sysdir);
  coinitialize(nil);
  ole2.OleInitialize(nil);

try
DecimalSeparator:='.';
 //LoadFromFile('rubic.ico');
config:='';
{$IFDEF BUSINESS_PROCESS}
config:=config+'Business_Process,';
{$ENDIF}
{$IFDEF LOGISTICS}
config:=config+'Logistics,';
{$ENDIF}
{$IFDEF LIGHTVERSION}
config:=config+'LightVersion,';
{$ENDIF}
logs.startproc('Struct','RUN','CONFIG:',config,1);
{$IFDEF Zastavka}
zast:=TZast.Create(application);
{$ENDIF}
try
{$IFDEF Zastavka}
zast.onupdate;
zast.Show;
 Application.ProcessMessages;

zast.Update;

{$ENDIF}
appconst.sysinfo.sprfilter:=$ffff;
if bigRG.OpenKeyReadOnly('SOFTWARE\Microsoft\Windows\CurrentVersion') then
Winsysdir:=BigRG.ReadString('SystemRoot');
logs.startproc('STRUCT','START','2',winsysdir,8);
{$IFNDEF DEMO}
{zast.CheckKey(config,i);
if i<>0 then
begin
 messagedlg(format(umessages.badkey,[config]),MtError,[mbOk],0);
 raise exception.create('KEY:'+config);
end;}
{if hasp.checkcrack(winsysdir+'\system',haspcrackname) then
begin
 messagedlg(format(umessages.badhasp,[winsysdir,haspcrackname]),MtError,[mbOk],0);
 raise exception.create('Hasp');
end;}
{$ENDIF}
 DeleteFile(appconst.LocalModelFile);
 DeleteFile(appconst.LocalModelFileMB);

Application.HintHidePause:=25000;
//with application do title:=appconst.applicationname;
  finfo:=TStringList.create;
  Application.Title := '-';
  Application.CreateForm(TOrgMasterMain, OrgMasterMain);
  Application.CreateForm(Toptions, options);
  Application.CreateForm(TNewCompItemLT, NewCompItemLT);
  Application.CreateForm(TNewComps, NewComps);
  Application.CreateForm(TSTRTables, STRTables);
  Application.CreateForm(TPrintMarkSel, PrintMarkSel);
  Application.CreateForm(TPrintProSel, PrintProSel);
  Application.CreateForm(TPrintMatSel, PrintMatSel);
  Application.CreateForm(TFind, Find);
  Application.CreateForm(TReplace, Replace);
  application.processMessages;
  Application.CreateForm(TPrintPreview, PrintPreview);
logs.startproc('STRUCT','START','8','Forms Created',8);
  if logs.Mainlog.getdebug>200 then finfo.savetofile('struct.obj');
  finfo.free;
  finally
{$IFDEF Zastavka}
zast.free;
{$ENDIF}
 BigRG.free;
 BigINI.Free;
end;
except
 logs.Mainlog.endlog;
 application.onexception:=nil;
 application.terminate;
raise   ;
 exit;
end;
try
cns:=mrOk;
if ((paramstr(1)='') or not fileexists(paramstr(1))) then
begin
openWzd:=TOpenWzd.create(nil);
try
cns:= openwzd.showmodal;
finally
openwzd.free;
end;
end;

if cns=mrOk then
  Application.Run;
finally
Logs.MainLog.TraceWindow:=nil;
 //CoUninitialize;
 Ole2.OleUninitialize;

Application.OnException:=nil;
//  couninitialize;
end;
finally
GlobalDeleteAtom(atom);
application.ProcessMessages;
sleep(10);
Application.OnException:=nil;
logs.MainLog.endlog;
end;
finally

end;
finally
 freeandnil(logs.MainLog);
 //LogTracer.Free;
end;
//closehandle(mx);
end.
