unit MyStringUnit;

interface

Uses Windows,SysUtils;

Type TDateUnderline=record
       dFisrt:Integer;
       dLength:Integer;
       mFisrt:Integer;
       mLength:Integer;
       yFirst:Integer;
       yLength:Integer;
     end;

Const nLineSpacing='                              ';

function GetDocumentDateString(Value:TDateTime;ShowDate,Ghost:Boolean;Russian:Boolean):String;
function GetDocumentDateUnderline(Value:TDateTime;ShowDate,Ghost:Boolean):TDateUnderline;
function GetDocumentFIOString(Value:String):String;
function GetDocumentFIOUnderline:Integer;

implementation

function GetDocumentDateString(Value:TDateTime;ShowDate,Ghost:Boolean;Russian:Boolean):String;
var day,month,year:String;
begin
  if ShowDate then
  begin
   if Ghost then
   begin
     day:=FormatDateTime('dd',Value);
     month:=FormatDateTime('mm',Value);
     year:=FormatDateTime('yy',Value);
     Result:=day+'.'+month+'.'+year;
   end
   else
   begin
  day:=FormatDateTime('dd',Value);
  month:=FormatDateTime('mmmm',Value);
  if Russian then
   begin
  if (month[length(month)]='') or
     (month[length(month)]='') then
     month[length(month)]:=''
  else
     month:=month+'';
   end;
  while length(month)<> 8 do
   month:=' '+month;
  year:=FormatDateTime('yyyy',Value);
  if Russian then
   Result:='" '+day+'"'+' '+month+'  '+year+' .'
  else
   Result:='" '+day+'"'+' '+month+'  '+year+'   ';
   end;
  end
  else
   begin
   if Ghost then
    Result:='    .    .     '
   else
   begin
   year:=FormatDateTime('yyyy',Value);
   year:=copy(year,1,2);
   if Russian then
     Result:='"    "                       '+Year+'     .'
    else
     Result:='"    "                       '+Year+'       ';
   end;
   end;
end;

function GetDocumentDateUnderline(Value:TDateTime;ShowDate,Ghost:Boolean):TDateUnderline;
begin
  if ShowDate then
  begin
   if Ghost then
    begin
  Result.dFisrt:=0;
  Result.dLength:=0;
  Result.mFisrt:=3;
  Result.mLength:=0;
  Result.yFirst:=6;
  Result.yLength:=0;
    end
   else
   begin
  Result.dFisrt:=1;
  Result.dLength:=3;
  Result.mFisrt:=5;
  Result.mLength:=10;
  Result.yFirst:=20;
  Result.yLength:=0;
   end;
  end
  else
   begin
    if Ghost then
    begin
     Result.dFisrt:=0;
     Result.dLength:=4;
     Result.mFisrt:=5;
     Result.mLength:=4;
     Result.yFirst:=10;
     Result.yLength:=4;
    end
    else
    begin
    Result.dFisrt:=1;
    Result.dLength:=4;
    Result.mFisrt:=7;
    Result.mLength:=19;
    Result.yFirst:=31;
    Result.yLength:=4;
    end;
   end;
end;

function GetDocumentFIOString(Value:String):String;
begin
 Result:=nLineSpacing+Value;
end;

function GetDocumentFIOUnderline:Integer;
begin
 Result:=Length(nLineSpacing)-1;
end;

end.
