program Etap3;

uses
  ShareMem,
  Windows,
  SysUtils,
  Forms,
  Printers,
  MainFormUnit in 'MainFormUnit.pas' {MainForm},
  SetupLevelsFormUnit in 'SetupLevelsFormUnit.pas' {LevelSetupForm},
  StartUpFormUnit in 'StartUpFormUnit.pas' {StartUpForm},
  CheckDateUnit in 'CheckDateUnit.pas',
  FileNameUnit in 'FileNameUnit.pas',
  PreviewFormUnit in 'PreviewFormUnit.pas' {PreviewForm},
  DebugUnit in 'DebugUnit.pas',
  OrgChart in 'OrgChart.pas',
  AboutBoxUnit in 'AboutBoxUnit.pas' {AboutBox},
  SelWEBImageDlgUnit in 'SelWEBImageDlgUnit.pas' {SelWEBImageDlg},
  ScaledFormUnit in 'ScaledFormUnit.pas' {ScaledForm},
  BPPropDlgUnit in 'BPPropDlgUnit.pas' {BPPropDlg},
  PBarDlgUnit in 'PBarDlgUnit.pas' {PBarDlg},
  SelAFTableDlgUnit in 'SelAFTableDlgUnit.pas' {SelAFTableDlg},
  OrgDef in 'OrgDef.pas',
  RichEdit2 in '..\..\..\Program Files\Borland\Delphi 3\HLAM\Richedit2.pas',
  BPNav in '..\BP\BPNav.pas';

{$R *.RES}
Var buf:TMemoryStatus;

begin
  buf.dwLength:=SizeOf(TMemoryStatus);
  GlobalMemoryStatus(buf);
  MainFormUnit.BeforeStart:=buf.dwMemoryLoad;
  MainFormUnit.HasPrn:=CheckAndSetWorkingPrinter; { Fix It }
  OrgChart.HasPrn:=MainFormUnit.HasPrn;
  PreviewForm:=nil;
  StartUpForm:=TStartUpForm.Create(Application);
  StartUpForm.Show;
  StartUpForm.Update;
  Application.Initialize;
  Application.Title := ' ';
  Application.HelpFile  := 'Orgchart.hlp';
//  Application.HelpFile:= ExtractFilePath(Application.ExeName)+'Orgchart.hlp';
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TAboutBox, AboutBox);
  Application.CreateForm(TSelWEBImageDlg, SelWEBImageDlg);
  Application.CreateForm(TBPPropDlg, BPPropDlg);
  Application.CreateForm(TPBarDlg, PBarDlg);
  Application.CreateForm(TSelAFTableDlg, SelAFTableDlg);
  StartUpForm.Close;
  Application.Run;
end.
