unit EdtPrItmLT;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  NewPrItm, ToolEdit, Mask, StdCtrls, ComCtrls, Db, DBTables, checklst,
  ExtCtrls;

type
  TEdtCompItem = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    PrjName: TEdit;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    FN: TEdit;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Avtor: TEdit;
    MDates: TDateEdit;
    Prim: TMemo;
    NewCompItem: TButton;
    CancelBtn: TButton;
    
    procedure FormActivate(Sender: TObject);
    procedure NewCompItemClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  EdtCompItem: TEdtCompItem;

implementation
 Uses Main,CompOps, appConst,DCOMMON,strutils, utils;
{$R *.DFM}

procedure TEdtCompItem.FormActivate(Sender: TObject);
var t:integer;
    tp:TPComp;
    folderpath:string;
    modelpath:string;
begin
{$IFDEF VIEW}
NewCompItem.visible:=false;
{$ENDIF}
 t:=TPComp(OrgMasterMain.CompView.Selected.Data)^.N;
 tp:=TPComp(OrgMasterMain.CompView.Selected.Parent.Data);
 if tp<>nil then
  folderpath:=expandFileName(tp^.FileName)
 else
 folderpath:='';
 if ANSIStartsText(appconst.sysinfo.datadir,folderpath) then folderpath:='';
 OrgMasterMain.Comp.First;
 While not OrgMasterMain.Comp.EOF do
 begin
 if (OrgMasterMain.Comp.FieldByName('N').AsInteger=t) and (OrgMasterMain.Comp.FieldByName('IsGroup').AsBoolean=false) then
 begin

PrjName.Text:=OrgMasterMain.Comp.FieldByName('ItemName').AsString;
modelpath:=OrgMasterMain.Comp.FieldByName('FileName').AsString;
if modelpath=expandfilename(modelpath) then
FN.Text:=modelpath
else
FN.Text:=folderpath+modelpath;
Prim.Text:=OrgMasterMain.Comp.FieldByName('Comment').AsString;
MDates.Date:=OrgMasterMain.Comp.FieldByName('MdfDate').AsDateTime;
Avtor.text:=OrgMasterMain.Comp.FieldByName('Avtor').AsString;
 exit;
 end;
  OrgMasterMain.Comp.Next;
 end;



end;

procedure TEdtCompItem.NewCompItemClick(Sender: TObject);
begin
{$IFNDEF VIEW}
OrgMasterMain.comp.Edit;
OrgMasterMain.Comp.FieldByName('ItemName').AsString:=ClearSpaces(PrjName.Text);
//OrgMasterMain.Comp.FieldByName('FileName').AsString:=FN.Text;
OrgMasterMain.Comp.FieldByName('Comment').AsString:=Prim.Text;
OrgMasterMain.Comp.FieldByName('Avtor').AsString:=Avtor.Text;
OrgMasterMain.Comp.FieldByName('Flags').AsInteger:=0;
OrgMasterMain.comp.Post;

//TPcomp(OrgMasterMain.CompView.Selected.Data)^.FileName:=FileName.Text;
OrgMasterMain.CompView.Selected.Text:=PrjName.Text;
TPComp(OrgMasterMain.CompView.Selected.Data)^.Comment:=Prim.Text;
TPComp(OrgMasterMain.CompView.Selected.Data)^.Avtor:=Avtor.Text;

modalResult:=mrOk;
{$ENDIF}
end;

procedure TEdtCompItem.FormHide(Sender: TObject);
begin
  inherited;
GroupBox2.visible:=true;
caption:=' ';
end;

end.
