unit MPMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, Menus, ComCtrls, ImgList,ShellApi, Placemnt,
  Mask, ToolEdit, OleServer, Word2000;

type
  TMPMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Label1: TLabel;
    NextButton: TSpeedButton;
    PrevButton: TSpeedButton;
    AbortButton: TSpeedButton;
    Notebook: TNotebook;
    Label2: TLabel;
    Image1: TImage;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Label9: TLabel;
    UFirmaEdit: TComboBox;
    URangeEdit: TComboBox;
    UFIOEdit: TComboBox;
    UDateEdit: TDateTimePicker;
    useLU: TCheckBox;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    PFileID: TLabel;
    PreamMemo: TMemo;
    usePreambula: TCheckBox;
    PreamLoadButton: TSpeedButton;
    PSMemo: TMemo;
    usePostscriptum: TCheckBox;
    PSLoadButton: TSpeedButton;
    PGrifEdit: TComboBox;
    AuthorRangeEdit: TComboBox;
    AuthorEdit: TComboBox;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    usePodpis: TCheckBox;
    Label26: TLabel;
    AddOLVButton: TSpeedButton;
    DelOLVButton: TSpeedButton;
    ImageList1: TImageList;
    OtherRangeEdit: TComboBox;
    ONameEdit: TComboBox;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    ODateEdit: TDateTimePicker;
    useLP: TCheckBox;
    EGrifEdit: TComboBox;
    Label30: TLabel;
    RadioGroup1: TRadioGroup;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    HGrifEdit: TComboBox;
    Label22: TLabel;
    useHeader: TCheckBox;
    UDateFormat: TComboBox;
    Label31: TLabel;
    EDateFormat: TComboBox;
    Label32: TLabel;
    ReportEdit: TEdit;
    OtherView: TListBox;
    FormStorage1: TFormStorage;
    UseLogo: TCheckBox;
    LogoFile: TFilenameEdit;
    SaveFormat: TComboBox;
    ListEdit: TSpeedButton;
    MakeReport: TButton;
    ReadyButton: TSpeedButton;
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AbortButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure PrevButtonClick(Sender: TObject);
    procedure OLPopupClick(Sender: TObject);
    procedure ExceptionH(Sender: TObject; E: Exception);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PSLoadButtonClick(Sender: TObject);
    procedure PreamLoadButtonClick(Sender: TObject);
    procedure NotebookPageChanged(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AddOLVButtonClick(Sender: TObject);
    procedure DelOLVButtonClick(Sender: TObject);
    procedure OtherViewChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure useLPClick(Sender: TObject);
    procedure usePodpisClick(Sender: TObject);
    procedure usePostscriptumClick(Sender: TObject);
    procedure usePreambulaClick(Sender: TObject);
    procedure useLUClick(Sender: TObject);
    procedure OtherViewEdited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure ONameEditChange(Sender: TObject);
    procedure OtherRangeEditChange(Sender: TObject);
    procedure ODateEditChange(Sender: TObject);
    procedure useHeaderClick(Sender: TObject);
    procedure OtherViewClick(Sender: TObject);
    procedure EGrifEditChange(Sender: TObject);
    procedure UFIOEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SaveFormatClick(Sender: TObject);
    procedure ListEditClick(Sender: TObject);
    procedure EDateFormatEnter(Sender: TObject);
    procedure OtherRangeEditClick(Sender: TObject);
    procedure URangeEditClick(Sender: TObject);
    procedure AuthorRangeEditClick(Sender: TObject);
    procedure ReadyButtonClick(Sender: TObject);
  private
    { Private declarations }
    RangeHolder:TStringList;
    FirmaHolder:TStringList;
    FIOHolder:TStringList;
    FIO_RANGEHolder:TStringList;
    Holders:array[1..3] of TStringList;
    FSource:TStringList;
    FDest:TStringList;
    FWEB:TStringList;
    FFileName:String;
    FOldPage:String;
    FCharSet:TFontCharSet;
    RangePosition:integer;
    WordLanguage:integer;
    procedure SetButtonEnable(Page:Integer);
    procedure SetPage(Page:Integer);
    procedure SetOLControl(Page:Integer);
    procedure Convert;
    procedure LoadHolders;
    procedure WriteHolders;
    procedure ResyncRangeHolders(Sender: TObject);
    procedure ResyncFIOHolders(Sender: TObject);
    procedure ResyncFirmaHolders(Sender: TObject);
    procedure UpdateHolders(id:integer);
    procedure UpdateAllHolders(Sender:TObject);
    procedure UpdateRangeHolder(Value:String);
    procedure UpdateFIOHolder(Value:String);
    procedure UpdateFirmaHolder(Value:String);
    procedure ClearOLV;
    function GetReportName:string;
    procedure CreateLU;
    procedure CreateHeader;
    procedure CreatePream;
    procedure CreatePS;
    procedure CreatePodpis;
    procedure CreateLS;
    function  GetDocumentDateString(Value:TDateTime;ShowDate,Ghost:Boolean;Russian:Boolean):String;
    procedure SaveAsWEB;
    procedure setupCharset(charset:TFontcharset);
    procedure SavePreferences;
    procedure getRTFFormats;
    procedure toword(template:string);
    procedure UpdateFIOS(RP:integer;list:TComboBox);
  public
    { Public declarations }
  end;

  POtherViewRecord=^TOtherViewRecord;
  TOtherViewRecord=packed record
    Range:ShortString;
    Date:TDateTime;
  end;

var
  MPMainForm: TMPMainForm;


Const
  SPage=1;
  EPage=8;

  RangeFile = 'range.cfg';
  FIOFile = 'fio.cfg';
  FirmaFile = 'firm.cfg';
  FIORangeFile='Range_FIO.cfg';

implementation

uses wordexport, leform, utils,strutils;

{$R *.DFM}

procedure TMPMainForm.SaveAsWEB;
Var repModel:String;
    repReport:String;
    s,l:String;
    i,ic:Integer;
 begin
   repReport:=ReportEdit.Text;
   s:=FFileName;
   FWEB.Clear;
   s:=ExtractFilePath(s); { Model Dir }
   s:=copy(s,1,length(s)-1);
   repModel:=ExtractFileName(s);
   s:=ExtractFilePath(s); { Reports Dir }
   s:=copy(s,1,length(s)-1);
   s:=ExtractFilePath(s); { MASTER Dir }
   s:=copy(s,1,length(s)-1);
   s:=ExtractFilePath(s); { ROOT Dir }
   s:=s+'HTML';
   CreateDir(s);
   s:=s+'\'+repModel;
   CreateDir(s);
   s:=s+'\'+repReport+'.htm';
   ic:=FDest.Count-1;
   for i:=0 to ic do
     begin
       l:=FDest.Strings[i];
       if (pos('<BODY>',l)>0) then
        FWEB.ADD('<#BODYSTART>')
        else
       begin
        if (pos('</BODY>',l)>0) then
         FWEB.Add('<#BODYEND>')
        else
         FWEB.Add(l);
       end;
       if (pos('<HTML>',l)>0) then
           FWEB.Add('<#COPYRIGHT>');
     end;
   FWEB.SaveToFile(s);
 end;

function TMPMainForm.GetDocumentDateString(Value:TDateTime;ShowDate,Ghost:Boolean;Russian:Boolean):String;
var day,month,year:String;
begin
  if ShowDate then
  begin
   if Ghost then
   begin
     day:=FormatDateTime('dd',Value);
     month:=FormatDateTime('mm',Value);
     year:=FormatDateTime('yy',Value);
     Result:=day+'.'+month+'.'+year;
   end
   else
   begin
  day:=FormatDateTime('dd',Value);
  month:=FormatDateTime('mmmm',Value);
  if Russian then
   begin
  if (month[length(month)]='') or
     (month[length(month)]='') then
     month[length(month)]:=''
  else
     month:=month+'';
   end;
  while length(month)<> 8 do
   month:=' '+month;
  year:=FormatDateTime('yyyy',Value);
  if Russian then
  Result:='"<U> '+day+'</U>"'+'<U> '+month+'</U>  '+year+' .'
  else
  Result:='"<U> '+day+'</U>"'+'<U> '+month+'</U>  '+year+'   ';
   end;
  end
  else
   begin
   if Ghost then
    Result:='<U>    </U>.<U>    </U>.<U>     </U>'
   else
   begin
   year:=FormatDateTime('yyyy',Value);
   year:=copy(year,1,2);
   if Russian then
   Result:='"<U>    </U>"<U>                      </U> '+Year+'     .'
   else
   Result:='"<U>    </U>"<U>                      </U> '+Year+'     .';
   end;
   end;
end;


function TMPMainForm.GetReportName:string;
Var i,ic:Integer;
    flag:Boolean;
    s:String;
    n,m:Integer;
 begin
   {}
   ic:=FSource.Count;
   i:=0;
   Flag:=True;
   while (i<ic) and flag do
     begin
       s:=FSource.Strings[i];
       n:=pos('<TITLE>',s);
       if (n<>0) then
         begin
           m:=pos('</TITLE>',s);
           n:=n+7;
           pFileID.Caption:=copy(s,n,m-n);
           ReportEdit.Text:=pFileID.Caption;
           flag:=False;
         end
       else
       inc(i);
     end;
Result:=ReportEdit.text;     
 end;

procedure TMPMainForm.ClearOLV;
Var i,ic:Integer;
 begin
   ic:=OtherView.Items.Count;
   if ic=0 then Exit;
   for i:=0 to (ic-1) do
     begin
       FreeMem(pointer(OtherView.Items.objects[i]),sizeOf(TOtherViewRecord));
     end;
   OtherView.Items.Clear;
 end;

procedure TMPMainForm.UpdateAllHolders(Sender:TObject);
 Var i,ic:Integer;
     p:POtherViewRecord;
 begin
 if (FOldPage = '2') and
    (useLU.Checked) then
     begin
       UpdateRangeHolder(URangeEdit.Text);
       UpdateFIOHolder(UFIOEdit.Text);
       UpdateFirmaHolder(UFirmaEdit.Text);
       ResyncRangeHolders(self);
       ResyncFIOHolders(self);
       ResyncFirmaHolders(self);
     end;
 if (FOldPage = '6') and
    (usePodpis.Checked) then
     begin
       UpdateRangeHolder(AuthorRangeEdit.Text);
       UpdateFIOHolder(AuthorEdit.Text);
       ResyncRangeHolders(self);
       ResyncFIOHolders(self);
     end;
 if (FOldPage = '7') and
    (useLP.Checked) then
     begin
      {  ToDo
      UpdateRangeHolder(OtherRangeEdit.Text);}
      ic:=OtherView.Items.Count;
      for i:=0 to (ic-1) do
        begin
          UpdateFioHolder(OtherView.Items[i]);
          p:=POtherViewRecord(OtherView.Items.objects[i]);
          UpdateRangeHolder(p^.Range);
        end;
       ResyncRangeHolders(self);
       ResyncFIOHolders(self);
     end;
 end;


procedure TMPMainForm.WriteHolders;
var s:String;
 begin
   s:=ExtractFilePath(Application.ExeName);
   if (RangeHolder.Count>0) then
    RangeHolder.SaveToFile(s+RangeFile);
   if (FIOHolder.Count>0) then
    FIOHolder.SaveToFile(s+FIOFile);
   if (FirmaHolder.Count>0) then
    FirmaHolder.SaveToFile(s+FirmaFile);
   RangeHolder.Clear;
   FIOHolder.Clear;
   FirmaHolder.Clear;
   FIO_RANGEHolder.Clear;
 end;


procedure TMPMainForm.LoadHolders;
Var s:String;
 begin
   RangeHolder.Clear;
   FIOHolder.Clear;
   FirmaHolder.Clear;
   FIO_RANGEHolder.Clear;
   s:=ExtractFilePath(Application.ExeName);
   if FileExists(s+RangeFile) then
    RangeHolder.LoadFromFile(s+RangeFile);
   if FileExists(s+FIOFile) then
    FIOHolder.LoadFromFile(s+FIOFile);
   if FileExists(s+FirmaFile) then
    FirmaHolder.LoadFromFile(s+FirmaFile);
   if FileExists(s+FIORangeFile) then
   FIO_RANGEHolder.LoadFromFile(s+FIORangeFile);
   ResyncRangeHolders(self);
   ResyncFIOHolders(self);
   ResyncFirmaHolders(self);
 end;

procedure TMPMainForm.UpdateRangeHolder(Value:String);
 begin
   if (RangeHolder.IndexOf(Value)=-1) then
   RangeHolder.Add(Value);
 end;

procedure TMPMainForm.UpdateFIOHolder(Value:String);
 begin
   if (FIOHolder.IndexOf(Value)=-1) then
   begin
   FIOHolder.Add(Value);
   if (FIO_RANGEHolder.Count>0)and
       (RangePosition>=0) then
       FIO_RANGEHolder.Add(intTostr(RangePosition)+'-'+intTostr(FIOHolder.Count));
   end;
 end;

procedure TMPMainForm.UpdateFirmaHolder(Value:String);
 begin
   if (FirmaHolder.IndexOf(Value)=-1) Then
   FirmaHolder.Add(Value);
 end;

procedure TMPMainForm.ResyncRangeHolders(Sender: TObject);
 begin
  {}
   AuthorRangeEdit.Items.Clear;
   URangeEdit.Items.Clear;
   OtherRangeEdit.Items.Clear;
   AuthorRangeEdit.Items.Assign(RangeHolder);
   OtherRangeEdit.Items.Assign(RangeHolder);
   URangeEdit.Items.Assign(RangeHolder);
 end;

procedure TMPMainForm.ResyncFIOHolders(Sender: TObject);
 begin
  {}
   AuthorEdit.Items.Clear;
   UFIOEdit.Items.Clear;
   AuthorEdit.Items.Assign(FIOHolder);
   UFIOEdit.Items.Assign(FIOHolder);
   ONameEdit.Items.Assign(FIOHolder);
 end;

procedure TMPMainForm.CreateLU;
 begin
  {}
   if useLU.Checked then
     begin
      FDest.Add('<P ID=ASSERT_SHEET_P>');
      FDest.Add('<FONT ID=ASSERT_SHEET_FONT>');
      FDest.Add(HGrifEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      FDest.Add('<P ID=ASSERT_SHEET_P>');
      FDest.Add('<FONT ID=ASSERT_SHEET_FONT>');
      FDest.Add(URangeEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      FDest.Add('<P ID=ASSERT_SHEET_P>');
      FDest.Add('<FONT ID=ASSERT_SHEET_FONT>');
      FDest.Add(UFirmaEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      FDest.Add('<P ID=ASSERT_SHEET_P>');
      FDest.Add('<FONT ID=ASSERT_SHEET_FONT>');
      FDest.Add('<U>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</U>'+UFIOEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      FDest.Add('<P ID=ASSERT_SHEET_P>');
      FDest.Add('<FONT ID=ASSERT_SHEET_FONT>');
      case (UDateFormat.Items.IndexOf(UDateFormat.Text)) of
        0:  FDest.Add(GetDocumentDateString(UDateEdit.DateTime,True,True,FCharSet=204));
        1:  FDest.Add(GetDocumentDateString(UDateEdit.DateTime,False,True,FCharSet=204));
        2:  FDest.Add(GetDocumentDateString(UDateEdit.DateTime,True,False,FCharSet=204));
        3:  FDest.Add(GetDocumentDateString(UDateEdit.DateTime,False,False,FCharSet=204));
       else FDest.Add(GetDocumentDateString(UDateEdit.DateTime,True,True,FCharSet=204));
      end;
      FDest.Add('</FONT>');
      FDest.Add('</P>');
     end
   else
     begin
      FDest.Add('<P ID=ASSERT_SHEET_P>');
      FDest.Add('<FONT ID=ASSERT_SHEET_FONT>');
      FDest.Add(HGrifEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
     end;
 end;
function InetFileName(s:string):string;
var i:integer;
begin
result:='file:///';
for i:=1 to length(s) do
if s[i]=':' then result:=result+'|'
else if s[i]='\' then result:=result+'/'
else result:=result+s[i];
end;
procedure TMPMainForm.CreateHeader;
 begin
  if UseLogo.checked and fileexists(logofile.filename) then
   begin
   FDest.Add('<LEFT><IMG SRC="'+InetFileName(logofile.filename)+'"></LEFT>');
   end;
   if useHeader.Checked then
     begin
       FDest.Add('&nbsp');
       FDest.Add('<P ID=HEADER_P>');
       FDest.Add('<FONT ID=HEADER_FONT>');
       FDest.Add(ReportEdit.Text);
       FDest.Add('</FONT>');
       FDest.Add('</P>');
     end;
 end;

procedure TMPMainForm.CreatePream;
 begin
  {}
   if usePreambula.Checked then
     begin
      FDest.Add('&nbsp');
      FDest.Add('<P ID=PREAMBULA_P>');
      FDest.Add('<FONT ID=PREAMBULA_FONT>');
      FDest.AddStrings(PreamMemo.Lines);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
     end;
 end;

procedure TMPMainForm.CreatePS;
 begin
  {}
   if usePostscriptum.Checked then
      begin
       FDest.Add('&nbsp');
       FDest.Add('<P ID=POSTSCRIPTUM_P>');
       FDest.Add('<FONT ID=POSTSCRIPTUM_FONT>');
       FDest.AddStrings(PSMemo.Lines);
       FDest.Add('</FONT>');
       FDest.Add('</P>');
      end;
 end;

procedure TMPMainForm.CreatePodpis;
 begin
  {}
   if usePodpis.Checked then
     begin
      FDest.Add('&nbsp');
      FDest.Add('<P ID=SIGNATURE_SHEET_P>');
      FDest.Add('<FONT ID=SIGNATURE_SHEET_FONT>');
      FDest.Add(PGrifEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      FDest.Add('<TABLE COLS=2 BORDER=0 WIDTH="75%">');
      FDest.Add('<TR>');
      FDest.Add('<TD ALIGN=LEFT WIDTH="50%">');
      FDest.Add('<P ID=SIGNATURE_SHEET_P>');
      FDest.Add('<FONT ID=SIGNATURE_SHEET_FONT>');
      FDest.Add(AuthorRangeEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      FDest.Add('</TD>');
      FDest.Add('<TD ALIGN=RIGHT>');
      FDest.Add('<P ID=SIGNATURE_SHEET_P>');
      FDest.Add('<FONT ID=SIGNATURE_SHEET_FONT>');
      FDest.Add('<U>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</U>'+AuthorEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      FDest.Add('</TD>');
      FDest.Add('</TR>');
      FDest.Add('</TABLE>');
     end;
 end;

procedure TMPMainForm.CreateLS;
var i,ic:Integer;
    p:POtherViewRecord;
 begin
  {}
   if useLP.Checked then
     begin
      FDest.Add('<P ID=COORDINATE_SHEET_P>');
      FDest.Add('&nbsp');
      FDest.Add('</P>');
      FDest.Add('<P ID=COORDINATE_SHEET_P>');
      FDest.Add('<FONT ID=COORDINATE_SHEET_FONT>');
      FDest.Add(EGrifEdit.Text);
      FDest.Add('</FONT>');
      FDest.Add('</P>');
      ic:=OtherView.Items.Count-1;
       for i:=0 to ic do
         begin
           p:=POtherViewRecord(OtherView.Items.objects[i]);
           FDest.Add('<P ID=COORDINATE_SHEET_P>');
           FDest.Add('<FONT ID=COORDINATE_SHEET_FONT>');
           FDest.Add(p^.Range);
           FDest.Add('</FONT>');
           FDest.Add('</P>');
           FDest.Add('<P ID=COORDINATE_SHEET_P>');
           FDest.Add('<FONT ID=COORDINATE_SHEET_FONT>');
           FDest.Add('<U>&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp</U>'+OtherView.Items[i]);
           FDest.Add('</FONT>');
           FDest.Add('</P>');
           FDest.Add('<P ID=COORDINATE_SHEET_P>');
           FDest.Add('<FONT ID=COORDINATE_SHEET_FONT>');
           case (EDateFormat.Items.IndexOf(EDateFormat.Text)) of
             0:  FDest.Add(GetDocumentDateString(p^.Date,True,True,FCharSet=204));
             1:  FDest.Add(GetDocumentDateString(p^.Date,False,True,FCharSet=204));
             2:  FDest.Add(GetDocumentDateString(p^.Date,True,False,FCharSet=204));
             3:  FDest.Add(GetDocumentDateString(p^.Date,False,False,FCharSet=204));
            else FDest.Add(GetDocumentDateString(p^.Date,True,True,FCharSet=204));
           end;
           FDest.Add('</FONT>');
           FDest.Add('</P>');
         end;
     end;
 end;


procedure TMPMainForm.ResyncFirmaHolders(Sender: TObject);
 begin
  {}
   UFirmaEdit.Items.Clear;
   UFirmaEdit.Items.Assign(FirmaHolder);
 end;

procedure TMPMainForm.Convert;
Var i,ic:Integer;
    n:Integer;
    s:String;
    flag1:Boolean;
 begin
  {}
   ic:=FSource.Count-1;
   FDest.Clear;
   Flag1:=False;
   for i:=0 to ic do
    begin
      s:=FSource.Strings[i];
      if flag1 then
        begin
          { Do Start}
          CreateLU;
          CreateHeader;
          CreatePream;
          flag1:=False;
        end;
      n:=pos('<BODY>',s);
      if (n<>0) then flag1:=True;
      n:=pos('</BODY>',s);
      if (n<>0) then
         begin
           { Do End }
           CreatePS;
           CreatePodpis;
           CreateLS;
         end;
      FDest.Add(s);
    end;
 end;

procedure TMPMainForm.SetOLControl(Page:Integer);
 begin
   if (page<SPage) or (page>EPage) then Exit;
   FOldPage:=Notebook.ActivePage;
   case (page) of
     1: Shape1MouseDown(Shape1,mbLeft,[],0,0);
     2: Shape1MouseDown(Shape2,mbLeft,[],0,0);
     3: Shape1MouseDown(Shape3,mbLeft,[],0,0);
     4: Shape1MouseDown(Shape4,mbLeft,[],0,0);
     5: Shape1MouseDown(Shape5,mbLeft,[],0,0);
     6: Shape1MouseDown(Shape6,mbLeft,[],0,0);
     7: Shape1MouseDown(Shape7,mbLeft,[],0,0);
     8: Shape1MouseDown(Shape8,mbLeft,[],0,0);
   end;
 end;

procedure TMPMainForm.SetPage(Page:Integer);
 begin
   FOldPage:=Notebook.ActivePage;
   if (page<SPage) or (page>EPage) then Exit;
   Notebook.ActivePage:=IntToStr(Page);
 end;

procedure TMPMainForm.SetButtonEnable(Page:Integer);
 begin
   PrevButton.Enabled:=(Page>SPage);
   NextButton.Enabled:=(Page<EPage);
 end;

procedure TMPMainForm.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Shape1.Shape:=stRoundRect;
  Shape1.Brush.Color:=clInfoBk;
  Shape2.Shape:=stRoundRect;
  Shape2.Brush.Color:=clBtnFace;
  Shape3.Shape:=stRoundRect;
  Shape3.Brush.Color:=clBtnFace;
  Shape4.Shape:=stRoundRect;
  Shape4.Brush.Color:=clBtnFace;
  Shape5.Shape:=stRoundRect;
  Shape5.Brush.Color:=clBtnFace;
  Shape6.Shape:=stRoundRect;
  Shape6.Brush.Color:=clBtnFace;
  Shape7.Shape:=stRoundRect;
  Shape7.Brush.Color:=clBtnFace;
  Shape8.Shape:=stRoundRect;
  Shape8.Brush.Color:=clInfoBk;
  Label1.Font.Style:=Label1.Font.Style-[fsBold];
  Label3.Font.Style:=Label3.Font.Style-[fsBold];
  Label4.Font.Style:=Label4.Font.Style-[fsBold];
  Label5.Font.Style:=Label5.Font.Style-[fsBold];
  Label6.Font.Style:=Label6.Font.Style-[fsBold];
  Label7.Font.Style:=Label7.Font.Style-[fsBold];
  Label1.Font.Color:=clBlack;
  Label3.Font.Color:=clBlack;
  Label4.Font.Color:=clBlack;
  Label5.Font.Color:=clBlack;
  Label6.Font.Color:=clBlack;
  Label7.Font.Color:=clBlack;
  case (Sender as TShape).Tag of
     1: begin
         Shape1.Shape:=stRectangle;
         Shape1.Brush.Color:=clHighlightText;
        end;
     2: begin
         Shape2.Shape:=stCircle;
         Shape2.Brush.Color:=clHighlightText;
         Label1.Font.Style:=Label1.Font.Style+[fsBold];
         Label1.Font.Color:=clWhite;
        end;
     3: begin
         Shape3.Shape:=stCircle;
         Shape3.Brush.Color:=clHighlightText;
         Label5.Font.Style:=Label5.Font.Style+[fsBold];
         Label5.Font.Color:=clWhite;
        end;
     4: begin
         Shape4.Shape:=stCircle;
         Shape4.Brush.Color:=clHighlightText;
         Label3.Font.Style:=Label3.Font.Style+[fsBold];
         Label3.Font.Color:=clWhite;
        end;
     5: begin
         Shape5.Shape:=stCircle;
         Shape5.Brush.Color:=clHighlightText;
         Label4.Font.Style:=Label4.Font.Style+[fsBold];
         Label4.Font.Color:=clWhite;
        end;
     6: begin
         Shape6.Shape:=stCircle;
         Shape6.Brush.Color:=clHighlightText;
         Label6.Font.Style:=Label6.Font.Style+[fsBold];
         Label6.Font.Color:=clWhite;
        end;
     7: begin
         Shape7.Shape:=stCircle;
         Shape7.Brush.Color:=clHighlightText;
         Label7.Font.Style:=Label1.Font.Style+[fsBold];
         Label7.Font.Color:=clWhite;
        end;
     8: begin
         Shape8.Shape:=stRectangle;
         Shape8.Brush.Color:=clHighlightText;
        end;
  end;
      SetPage((Sender as TShape).Tag);
      SetButtonEnable((Sender as TShape).Tag);
end;

procedure TMPMainForm.AbortButtonClick(Sender: TObject);
begin
  close;
end;

procedure TMPMainForm.OKButtonClick(Sender: TObject);
begin
SavePreferences;
 SetOLControl(8);
 SaveDialog.FileName:='ggg.htm';
 if FFileName<>'' then
  begin
   SaveDialog.FileName:=FFileName;
   SaveDialog.InitialDir:=ExtractFilePAth(FFileName);
   case RadioGroup1.ItemIndex of
    0:  begin
         if SaveDialog.Execute then
          begin
          Convert;
           FDest.SaveToFile(SaveDialog.FileName);
           ShellExecute(0,'open',PChar(SaveDialog.FileName),nil,nil,SW_SHOWNORMAL);
          end;
        end;
    1:  begin
         if SaveDialog.Execute then
          begin
          Convert;
           SaveAsWEB;
          end;
        end;
    2:  begin
        if saveformat.ItemIndex=0 then
        begin
         if SaveDialog.Execute then
         begin
           Convert;
           FDest.SaveToFile(SaveDialog.FileName);
         end;
         end
         else
         begin
         toword('SAVETO\'+saveformat.Items[saveformat.ItemIndex]+'.doc');
         end;
        end;
   end;
  end;
 close;
end;

procedure TMPMainForm.NextButtonClick(Sender: TObject);
begin
  SetOLControl(StrToInt(Notebook.ActivePage)+1);
end;

procedure TMPMainForm.PrevButtonClick(Sender: TObject);
begin
 SetOLControl(StrToInt(Notebook.ActivePage)-1);
end;

procedure TMPMainForm.OLPopupClick(Sender: TObject);
begin
 SetOLControl((Sender as TMenuItem).Tag);
end;

procedure TMPMainForm.ExceptionH(Sender: TObject; E: Exception);
begin
 Application.ShowException(E);
end;

procedure TMPMainForm.FormCreate(Sender: TObject);

begin
  Application.OnException:=ExceptionH;
  FCharSet:=204;
  FFileName:='';
  FOldPage:='0';
  RangeHolder:=TStringList.Create;
  FirmaHolder:=TStringList.Create;
  FioHolder:=TStringList.Create;
  FIO_RANGEHolder:=TStringList.Create;
  Holders[1]:=RangeHolder;
  Holders[2]:=FirmaHolder;
  Holders[3]:=FIOHolder;
  FSource:=TStringList.Create;
  FDest:=TStringList.Create;
  FWEB:=TStringList.Create;
  SetOLControl(1);
  UDateEdit.date:=now;
  ODateEdit.date:=now;
  LoadHolders;
  ///if ParamCount>0 then
    begin
      FSource.LoadFromFile('mp.htm');
      FFileName:= NormalFilename(GetReportName);
      if  ParamCount>0 then
       setupCharset(strtointdef(Paramstr(1),204))
        else
       setupCharset(204);
       wordlanguage:=StrToIntDef(Paramstr(2),$419);
    end;
 getRTFFormats;
 saveformat.ItemIndex:=0;
end;

procedure TMPMainForm.FormDestroy(Sender: TObject);
begin
  RangeHolder.Free;
  FioHolder.Free;
  FirmaHolder.Free;
  FSource.Free;
  FDest.Free;
  FWEB.Free;
  FIO_RANGEHolder.free;
  Application.OnException:=nil;
end;

procedure TMPMainForm.PSLoadButtonClick(Sender: TObject);
begin
 if OpenDialog.Execute then
  begin
   PSMemo.Lines.LoadFromFile(OpenDialog.FileName);
  end;
end;

procedure TMPMainForm.PreamLoadButtonClick(Sender: TObject);
begin
 if OpenDialog.Execute then
   begin
     PreamMemo.Lines.LoadFromFile(OpenDialog.FileName);
   end;
end;

procedure TMPMainForm.NotebookPageChanged(Sender: TObject);
begin
 UpdateAllHolders(self);
 ReadyButton.Visible:=NoteBook.PageIndex<7;
end;

procedure TMPMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 UpdateAllHolders(sender);
 WriteHolders;
 RangeHolder.Clear;
 FIOHolder.Clear;
 FirmaHolder.Clear;
 FSource.Clear;
 FDest.Clear;
 FWEB.Clear;
 ClearOLV;
 Action:=caFree;
end;

procedure TMPMainForm.AddOLVButtonClick(Sender: TObject);
Var ttt:TTreeNode;
    p:POtherViewRecord;
begin
 p:=POtherViewRecord(AllocMem(sizeof(TOtherViewRecord)));
 p^.Range:='<>';
 p^.Date:=Date;
 OtherView.Items.addObject('_'+inttostr(OtherView.items.count+1),TObject(p));
// ttt.ImageIndex:=2;
 OtherView.ItemIndex:=OtherView.Items.count-1;
 OtherView.Onclick(sender);
end;

procedure TMPMainForm.DelOLVButtonClick(Sender: TObject);
begin
 if (OtherView.ItemIndex >=0) then
  begin
  FreeMem(pointer(OtherView.items.objects[OtherView.ItemIndex]),sizeOf(TOtherViewRecord));
  OtherView.Items.Delete(OtherView.ItemIndex);
  end;
end;

procedure TMPMainForm.OtherViewChanging(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
Var p:POtherViewRecord;
begin
  ONameEdit.Text:=Node.Text;
  p:=POtherViewRecord(Node.Data);
  OtherRangeEdit.Text:=p^.Range;
  ODateEdit.DateTime:=p^.Date;
  AllowChange:=True;
end;

procedure TMPMainForm.useLPClick(Sender: TObject);
begin
  OtherView.Enabled:=useLP.Checked;
  EGrifEdit.Enabled:=useLP.Checked;
  OtherRangeEdit.Enabled:=useLP.Checked;
  ONameEdit.Enabled:=useLP.Checked;
  ODateEdit.Enabled:=useLP.Checked;
  AddOLVButton.Enabled:=useLP.Checked;
  DelOLVButton.Enabled:=useLP.Checked;
  EDateFormat.Enabled:=useLP.Checked;
  if (OtherView.itemindex>=0)then
  begin
  OtherView.itemindex:=0;
  OtherView.onClick(sender);
  end;
end;

procedure TMPMainForm.usePodpisClick(Sender: TObject);
begin
  AuthorRangeEdit.Enabled:=usePodpis.Checked;
  AuthorEdit.Enabled:=usePodpis.Checked;
  PGrifEdit.Enabled:=UsePodpis.Checked;
end;

procedure TMPMainForm.usePostscriptumClick(Sender: TObject);
begin
  PSMemo.Enabled:=usePostscriptum.Checked;
  PSLoadButton.Enabled:=usePostscriptum.Checked;
end;

procedure TMPMainForm.usePreambulaClick(Sender: TObject);
begin
 PreamMemo.Enabled:=usePreambula.Checked;
 PreamLoadButton.Enabled:=usePreambula.Checked;
end;

procedure TMPMainForm.useLUClick(Sender: TObject);
begin
  URangeEdit.Enabled:=useLU.Checked;
  UFirmaEdit.Enabled:=useLU.Checked;
  UFIOEdit.Enabled:=useLU.Checked;
  UDateEdit.Enabled:=useLU.Checked;
  UDateFormat.Enabled:=useLU.Checked;
  if useLU.Checked then HGrifEdit.Text:=''
   else HGrifEdit.Text:='';
end;

procedure TMPMainForm.OtherViewEdited(Sender: TObject; Node: TTreeNode;
  var S: String);
begin
  Node.Text:=S;
  ONameEdit.Text:=S;
end;

procedure TMPMainForm.ONameEditChange(Sender: TObject);
begin
with Sender as TComboBox do
begin
if (text<>'') then
begin
if OtherView.ItemIndex=-1 then Exit;
  OtherView.Items[OtherView.Itemindex]:=ONameEdit.Text;
end
else if (itemindex>=0) then
items.delete(itemindex);
end;
end;

procedure TMPMainForm.OtherRangeEditChange(Sender: TObject);
var p:POtherViewRecord;
begin
with Sender as TComboBox do
begin
if (text<>'') then
begin
  if OtherView.ItemIndex=-1 then Exit;
  p:=POtherViewRecord(OtherView.Items.Objects[OtherView.Itemindex]);
  p^.Range:=OtherRangeEdit.Text;
end
else if (itemindex>=0) then
items.delete(itemindex);
end;
end;

procedure TMPMainForm.ODateEditChange(Sender: TObject);
Var p:POtherViewRecord;
begin
  if OtherView.ItemIndex=-1 then Exit;
   p:=POtherViewRecord(OtherView.Items.Objects[OtherView.Itemindex]);
  p^.Date:=ODateEdit.DateTime;
end;

procedure TMPMainForm.useHeaderClick(Sender: TObject);
begin
  ReportEdit.Enabled:=useHeader.Checked;
end;
procedure TMPMainForm.setupCharset(charset:TFontcharset);
begin
FCharSet:=charset;
HGrifEdit.font.charset:=charset;
UFirmaEdit.font.charset:=charset;
URangeEdit.font.charset:=charset;
UFIOEdit.font.charset:=charset;
ReportEdit.font.charset:=charset;
PreamMemo.font.charset:=charset;
PSMemo.font.charset:=charset;
PGrifEdit.font.charset:=charset;
AuthorRangeEdit.font.charset:=charset;
AuthorEdit.font.charset:=charset;
EGrifEdit.font.charset:=charset;
OtherRangeEdit.font.charset:=charset;
ONameEdit.font.charset:=charset;
OtherView.font.charset:=charset;
end;
procedure TMPMainForm.OtherViewClick(Sender: TObject);
Var p:POtherViewRecord;
begin
  ONameEdit.Text:=OtherView.items[otherview.itemindex];
  p:=POtherViewRecord(OtherView.items.objects[otherview.itemindex]);
  OtherRangeEdit.Text:=p^.Range;
  ODateEdit.DateTime:=p^.Date;
end;
procedure TMPMainForm.SavePreferences;
begin
if HGrifEdit.items.indexof(HGrifEdit.text)=-1 then
   HGrifEdit.items.add(HGrifEdit.text);
if UFirmaEdit.items.indexof(UFirmaEdit.text)=-1 then
   UFirmaEdit.items.add(UFirmaEdit.text);
if URangeEdit.items.indexof(URangeEdit.text)=-1 then
   URangeEdit.items.add(URangeEdit.text);
if UFIOEdit.items.indexof(UFIOEdit.text)=-1 then
   UFIOEdit.items.add(UFIOEdit.text);
if EGrifEdit.items.indexof(EGrifEdit.text)=-1 then
   EGrifEdit.items.add(EGrifEdit.text);
if OtherRangeEdit.items.indexof(OtherRangeEdit.text)=-1 then
   OtherRangeEdit.items.add(OtherRangeEdit.text);
if ONameEdit.items.indexof(ONameEdit.text)=-1 then
   ONameEdit.items.add(ONameEdit.text);
if PGrifEdit.items.indexof(PGrifEdit.text)=-1 then
   PGrifEdit.items.add(PGrifEdit.text);
if AuthorRangeEdit.items.indexof(AuthorRangeEdit.text)=-1 then
   AuthorRangeEdit.items.add(AuthorRangeEdit.text);
if AuthorRangeEdit.items.indexof(AuthorRangeEdit.text)=-1 then
   AuthorRangeEdit.items.add(AuthorRangeEdit.text);
if AuthorEdit.items.indexof(AuthorEdit.text)=-1 then
   AuthorEdit.items.add(AuthorEdit.text);



end;
procedure TMPMainForm.EGrifEditChange(Sender: TObject);
begin
with Sender as TComboBox do
begin
if (itemindex>=0)and(Text='') then
items.delete(itemindex);
end
end;

procedure TMPMainForm.UFIOEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=VK_DELETE then
with TComboBox(sender) do
items.delete(itemindex);
end;
procedure TMPMainForm.getRTFFormats;
var p:integer;
    fr:TSearchRec;
begin
p:=findfirst('SAVETO\*.doc',0,fr);
while p=0 do
begin
saveformat.Items.Add(utils.CutFileExt(fr.Name));
p:=findnext(fr);
end;
findclose(fr);
end;
procedure TMPMainForm.toword(template:string);
var i:integer;
    s:string;
    msword:TMSWordDocument;
    p:POtherViewRecord;
begin

msword:=TMswordDocument.Create(utils.RemoveDuplicatedSlashes(extractfilepath(application.exename)+'\'+template),wordlanguage);
try
msword.templatedir:=extractfilepath(application.exename)+'PARTS';
if useLU.checked then
begin
msword.ConfirmData.tile:=HGrifEdit.text;
msword.ConfirmData.firm:=UFirmaEdit.text;
msword.ConfirmData.position:=URangeEdit.text;
msword.ConfirmData.fio:=UFIOEdit.text;
end
else
begin
msword.ConfirmData.tile:='';
msword.ConfirmData.firm:='';
msword.ConfirmData.position:='';
msword.ConfirmData.fio:='';
end;
if usePreambula.Checked then
 msWord.Preambula:=utils.RemoveCR(PreamMemo.Lines.Text)
 else
 msWord.Preambula:='';
if usePostscriptum.Checked then
 msWord.PostScriptum:=utils.RemoveCR(PSMemo.Lines.Text)
 else
 msWord.PostScriptum:='';

if  UseHeader.checked then
msword.Header:=ReportEdit.text
else
msword.Header:='';
if usePodpis.Checked then
begin
msword.SignData.title:=PGrifEdit.text;
msword.SignData.position:=AuthorRangeEdit.text;
msword.SignData.fio:=AuthorEdit.text;
end
else
begin
msword.SignData.title:='';
msword.SignData.position:='';
msword.SignData.fio:='';
end;
if useLP.checked then
begin
msword.ConsiderData.title:=Egrifedit.text;
msword.ConsiderData.count:=OtherView.items.count;
for i:=0 to OtherView.items.count-1 do
begin
p:=POtherViewRecord(OtherView.Items.Objects[i]);
msword.ConsiderData.positions[i+1]:= p^.Range;
msword.ConsiderData.fios[i+1]:=OtherView.Items[i];
end;
end
else
begin
msword.ConsiderData.title:='';
msword.ConsiderData.count:=0;

end;
msword.show;
msword.processInsertionPoints;
msword.show;
finally
msword.free;
end;
end;
procedure TMPMainForm.SaveFormatClick(Sender: TObject);
begin
radiogroup1.ItemIndex:=2;
end;

procedure TMPMainForm.ListEditClick(Sender: TObject);
begin
if (activecontrol is TCombobox)and
   (TCombobox(activecontrol).Style=csDropDown)and
   (TCombobox(activecontrol).Tag>0) then
begin
 ListEditForm:=TListEditForm.Create(nil);
 try
 ListEditForm.Memo1.Lines.Assign(Holders[(activecontrol as TCombobox).tag]);
 if ListEditForm.ShowModal=mrOK then
 Holders[(activecontrol as TCombobox).tag].assign(ListEditForm.Memo1.Lines);
 UpdateHolders((activecontrol as TCombobox).tag);
 finally
 ListEditForm.free;
 end;
end;
end;

procedure TMPMainForm.EDateFormatEnter(Sender: TObject);
begin
ListEdit.Visible:=(Sender is TCombobox)and
                  (TCombobox(Sender).Style=csDropDown)and
                  (TCombobox(Sender).tag>0);
end;
procedure TMPMainForm.UpdateHolders(id:integer);
begin
 case id of
 1: ResyncRangeHolders(nil);
 2: ResyncFirmaHolders(nil);
 3: ResyncFIOHolders(nil);
 end;
end;
procedure TMPMainForm.OtherRangeEditClick(Sender: TObject);
begin
RangePosition:=OtherRangeEdit.ItemIndex;
UpdateFIOS(RangePosition,ONameEdit);
ONameEdit.OnChange(ONameEdit);
end;

procedure TMPMainForm.URangeEditClick(Sender: TObject);
begin
RangePosition:=URangeEdit.ItemIndex;
UpdateFIOS(RangePosition,UFIOEdit);
end;

procedure TMPMainForm.AuthorRangeEditClick(Sender: TObject);
begin
RangePosition:=AuthorRangeEdit.ItemIndex;
UpdateFIOS(RangePosition,AuthorEdit);
end;
procedure TMPMainForm.UpdateFIOS(RP:integer;list:TComboBox);
var i,j:integer;
    template,res:string;
begin
if FIO_RANGEHolder.Count=0 then exit;
list.items.clear;
list.itemindex:=-1;
if RP=-1 then exit;
template:=inttostr(RP+1)+'-';
for i:=0 to FIO_RangeHolder.Count-1 do
 if AnsiStartsStr(template,FIO_RangeHolder[i]) then
 begin
 res:=copy(FIO_RangeHolder[i],length(template)+1,length(FIO_RangeHolder[i]));
 j:=strToIntDef(res,0);
 if j=0 then continue;
 list.Items.Add(FIOHolder[j-1]);
 end;
if list.Items.Count>0 then
list.ItemIndex:=0;
end;
procedure TMPMainForm.ReadyButtonClick(Sender: TObject);
begin
Shape8.OnMouseDown(Shape8,mbLeft,[],0,0);
end;

end.
