unit wordexport;

interface
uses Word_TLB;
Type
TConfirmData=record
               tile,
               firm,
               position,
               fio:string;
             end;
TSignData=record
           title,
           position,
           fio:string;
          end;
TConsiderData=record
               title:string;
               positions,fios:array[1..64] of string;
               count:integer;
              end;
TMSWordDocument=class
private
// fwordapp:word_tlb.TWordApplication;
 oleword:olevariant;
 fdoc,templatedoc:olevariant;
 fLanguage:integer;
public
 templatedir:string;
 ConfirmData:TConfirmData;
 Header:String;
 SignData:TSignData;
 ConsiderData:TConsiderData;
 Preambula,PostScriptum:string;
 constructor Create(filename:string;language:integer);
 destructor destroy;
 procedure processInsertionPoints;
 procedure Show;
 procedure OpenDoc(doc:String);
end;


implementation
uses comobj,sysutils,variants,activex,dialogs,classes;
var ua:olevariant;
   pemptystr,
    ptrue,
    pfalse:olevariant;
constructor   TMSWordDocument.Create(filename:string;language:integer);
const
wordGuid:TGUID='{000209FF-0000-0000-C000-000000000046}';
var docfile,tempfile,documenttype,docvisible:olevariant;

begin
 inherited Create;
 flanguage:=language;
 oleword:=CreateOleObject('Word.Application');
 oleword.Options.ReplaceSelection:=true;
// showmessage('WordOK');
 docfile:=filename;
 tempfile:=false;
 documenttype:=0;
 docvisible:=wordbool(true);
 try
 templateDoc:=(oleword.documents.Open(docfile,ReadOnly:=True));
 fDoc:=oleword.documents.add(docfile);
// fdoc.PageSetup.PaperSize:=wdPaperA4;
 If fdoc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        fdoc.ActiveWindow.ActivePane.View.Type := wdNormalView
    Else
        fdoc.ActiveWindow.View.Type := wdNormalView;
//  showmessage('docOK');
except
 Showmessage(' '+filename);
 raise;
 exit;
end;
end;
destructor  TMSWordDocument.destroy;
begin
//oleword:=nil;
inherited destroy;
end;
procedure TMSWordDocument.Show;
begin
oleword.visible:=true;
//fwordapp.UserControl:=true;
end;
 procedure TMSWordDocument.processInsertionPoints;
 var i,j,k,pos1,pcount:integer;
     insdoc,insdocname,insnewname,insdoctype,insvisible,partfont:olevariant;
     curpara:olevariant;
     curalign:Toleenum;
     paratext,paratext2,filename,pt,s:string;
     dorepeat:boolean;
     newpara:olevariant;
     paraformat:olevariant;
     paragraphs:TStringList;
     docpara:integer;
     keepformat:boolean;
     tail:string;
procedure setText(Doc,Paragraph:OleVariant;text:string);
begin
Sleep(10);
Paragraph.Range.select;
Sleep(0);
If doc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        doc.ActiveWindow.ActivePane.Selection.Typetext(text)
    Else
        doc.ActiveWindow.Selection.Typetext(text);
Sleep(10);
end;
 begin
 sleep(0);
  paragraphs:=TStringList.Create;
 try
 paragraphs.Text:=templateDoc.Content.Text;
 docpara:=0;
// showmessage('Loaded');
 for i:=0 to Paragraphs.Count-1 do
 begin
 inc(docpara);
 paratext:=trim(paragraphs[i]);
 paratext2:=paratext;
// paratext2:=TemplateDoc.Paragraphs.Item(i+1).range.text;
  curpara:=fdoc.Paragraphs.Item(docpara);
  paraformat:=curpara.format.duplicate;
  {If fdoc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        fdoc.ActiveWindow.ActivePane.Selection.CopyFormat
    Else
        fdoc.ActiveWindow.Selection.CopyFormat;}
//  partfont:=curPara.Range.Font.duplicate;
 if paratext='' then
 continue;
 // showmessage(paratext);
// sleep(0);
 if not (pos('%%%',paratext)=1) then
 continue;
 curalign:=curpara.range.paragraphformat.alignment;
 if (pos('%%%part',paratext)=1)or(pos('%%%parttext',paratext)=1) then
 begin
 if  pos('%%%parttext',paratext)=1 then
 begin
 s:=copy(paratext,12,2);
  pos1:=strtointdef(s,-1);
  keepformat:=false;
 end
  else
 begin
  s:=copy(paratext,8,2);
  pos1:=strtointdef(s,-1);
  keepformat:=true;
 end;
   if pos1=-1 then
  filename:=templatedir+'\preview.rtf'
  else
  filename:=templatedir+'\preview'+inttostr(pos1)+'.rtf';
  if fileexists(filename) then
  begin
  insdocname:=filename;
  insnewname:=false;
  insdoctype:=0;
  insvisible:=false;
  insdoc:=oleword.documents.Open(insdocname,ReadOnly:=True);
    sleep(0);
   //insdoc.PageSetup.PaperSize:=wdPaperA4;
  If insdoc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        insdoc.ActiveWindow.ActivePane.View.Type := wdNormalView
    Else
        insdoc.ActiveWindow.View.Type := wdNormalView;
  insdoc.range.Select;
  insdoc.range.copy;
  {
  If insdoc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        insdoc.ActiveWindow.ActivePane.Selection.Copy
    Else
        insdoc.ActiveWindow.Selection.Copy;
   }
  sleep(10);
  curPara:=fdoc.paragraphs.Item(docPara);
  curPara.range.select;
  if keepFormat then
  begin
  curPara.range.Paste;
  end
  else
  begin
  curPara.Range.PasteAndFormat(wdFormatPlainText);
  {curPara.Range.select;
   If fdoc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        fdoc.ActiveWindow.ActivePane.Selection.PasteFormat
    Else
        fdoc.ActiveWindow.Selection.PasteFormat;}
  end;
{  If fdoc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        fdoc.ActiveWindow.ActivePane.Selection.PasteAndFormat(wdFormatOriginalFormatting)
    Else
        fdoc.ActiveWindow.Selection.PasteAndFormat(wdFormatOriginalFormatting);}
{  if not keepformat then
  curpara.range.pasteAndFormat(wdFormatPlainText)
  else
  curpara.range.PasteAndFormat(00000000);}
  docpara:=docPara+insdoc.Paragraphs.count-1;
  //curpara.range.delete;
  insdoc.close;
  end;
 end
 else
 begin
 j:=0;
  repeat
  pos1:=pos('%%%confirm.title',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            confirmdata.tile+
            copy(paratext,pos1+length('%%%confirm.title'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%preambula',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            trim(Preambula)+
            copy(paratext,pos1+length('%%%preambula'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%postscriptum',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            trim(postscriptum)+
            copy(paratext,pos1+length('%%%preambula'),length(paratext))
  until (pos1=0)or (j>10);

 j:=0;
  repeat
  pos1:=pos('%%%confirm.firm',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            confirmdata.firm+
            copy(paratext,pos1+length('%%%confirm.firm'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%confirm.position',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            confirmdata.position+
            copy(paratext,pos1+length('%%%confirm.position'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%confirm.fio',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            confirmdata.fio+
            copy(paratext,pos1+length('%%%confirm.fio'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%header',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            header+
            copy(paratext,pos1+length('%%%header'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%signature.title',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            SignData.title+
            copy(paratext,pos1+length('%%%signature.title'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%signature.position',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            SignData.position+
            copy(paratext,pos1+length('%%%signature.position'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%signature.fio',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            SignData.fio+
            copy(paratext,pos1+length('%%%signature.fio'),length(paratext))
  until (pos1=0)or (j>10);

 j:=0;
  repeat
  pos1:=pos('%%%consider.title',paratext);
  inc(j);
  if pos1>0 then
  paratext:=copy(paratext,1,pos1-1)+
            considerdata.title+
            copy(paratext,pos1+length('%%%consider.title'),length(paratext))
  until (pos1=0)or (j>10);
 j:=0;
  repeat
  pos1:=pos('%%%consider.position',paratext);
  inc(j);
  if pos1>0 then
  begin
  paratext:=copy(paratext,1,pos1-1)+
            considerdata.positions[1]+
            copy(paratext,pos1+length('%%%consider.position'),length(paratext));
  dorepeat:=true;
  end;
  until (pos1=0)or (j>10);
  j:=0;
  repeat
  pos1:=pos('%%%consider.fio',paratext);
  inc(j);
  if pos1>0 then
  begin
  paratext:=copy(paratext,1,pos1-1)+
            considerdata.fios[1]+
            copy(paratext,pos1+length('%%%consider.fio'),length(paratext));
  dorepeat:=true;
  end;
  until (pos1=0)or (j>10);
pt:=paratext;
//curPara.range.insertparagraphafter;
SetText(fdoc,CurPara,paratext);
paratext:=pt;
sleep(0);
curpara:=fdoc.Paragraphs.Item(docpara);
dorepeat:=(pos('%%%consider.position',paratext2)>0)or(pos('%%%consider.fio',paratext2)>0);
if dorepeat  then
if considerdata.count>0 then
begin
//sleep(0);
for k:=2 to considerdata.count do
begin
 j:=0;
 paratext:=paratext2;
  repeat
  pos1:=pos('%%%consider.position',paratext);
  inc(j);
  if pos1>0 then
  begin
  paratext:=copy(paratext,1,pos1-1)+
            considerdata.positions[k]+
            copy(paratext,pos1+length('%%%consider.position'),length(paratext));
  dorepeat:=true;
  end;
  until (pos1=0)or (j>10);
  j:=0;
  repeat
  pos1:=pos('%%%consider.fio',paratext);
  inc(j);
  if pos1>0 then
  begin
  paratext:=copy(paratext,1,pos1-1)+
            considerdata.fios[k]+
            copy(paratext,pos1+length('%%%consider.fio'),length(paratext));
  dorepeat:=true;
  end;
  until (pos1=0)or (j>10);
curPara.Range.InsertParagraphAfter;
curPara:=fdoc.Paragraphs.item(docPara);
curPara.range.copy;
inc(docPara);
curPara:=fdoc.Paragraphs.item(docPara);
curPara.range.ParagraphFormat:=Paraformat;
curPara.range.select;
curPara.range.Paste;
{  If fdoc.ActiveWindow.View.SplitSpecial = wdPaneNone Then
        fdoc.ActiveWindow.ActivePane.Selection.PasteAndFormat(wdFormatOriginalFormatting)
    Else
        fdoc.ActiveWindow.Selection.PasteAndFormat(wdFormatOriginalFormatting);}
curPara:=fdoc.Paragraphs.item(docPara);        
SetText(fdoc,curPara,paratext);
paratext:=pt;
 end;
end;
 end;
//inc(docpara);
 end;
 finally
 paragraphs.free;
 end;
templatedoc.close(wdDoNotSaveChanges);
 end;
procedure TMSWordDocument.OpenDoc(doc:String);
var msword,newdoc:Olevariant;
begin
end;
end.
