unit PackT;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface
Uses SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, ComCtrls,
 ToolWin,   Db, DBTables,BDE,dcommon;

procedure PackTable(Tablefrom:TTable;tablename,saveAs:string;Cont:TModelArray;selected:boolean);
procedure AddType(Table: TTable);
implementation
uses dbutils,bdeutils,StrUtils,dbconsts,utils, logs, appconst;
function pc(p1,p2:pointer):integer;
begin
if integer(p1)<integer(p2) then result:=-1
         else
if integer(p1)>integer(p2) then result:=1
         else result:=0;
end;
procedure PackTable(Tablefrom:TTable;tablename,saveAs:string;Cont:TModelArray;selected:boolean);
{ This routine copied and modified from demo unit TableEnh.pas
  from Borland Int. }
var
  Table:TTable;
  CopyBM:TBatchMove;
  { FCurProp holds information about the structure of the table }
  FCurProp: CurProps;
  { Specific information about the table structure, indexes, etc. }
  TblDesc: CRTblDesc;
  { Uses as a handle to the database }
  hDb: hDbiDB;
  { Path to the currently opened table }
  TablePath: array[0..dbiMaxPathLen] of Char;
  Exclusive: Boolean;
  i,j:integer;
  tp:string;
  m:TList;
  mo:PModelObject;
begin
logs.startProc('PackT','PackTable',tablename,saveAs,5);
Table:=TTable.create(nil);
copyBM:=TBatchMove.create(nil);
//showmessage(tablename+#13#10+SaveAs);
try
tp:=tablefrom.tablename;
tablefrom.tablename:=tablename;
utils.copySTRfile('DOTS\normal.$$$',tablename,nil);
logs.startProc('PackT','PackTable','1','',5);
tablefrom.tablename:=tp;
Table.TableName:=tablename;
copyBM.Destination:=table;
copyBM.source:=tablefrom;
copyBM.Mode:=batCopy;
table.sessionName:=tablefrom.sessionName;
logs.startProc('PackT','PackTable','2','',5);
tablefrom.open;
tablefrom.close;
logs.startProc('PackT','PackTable','3','',5);
//table.Locale:=tablefrom.locale;
copyBM.Transliterate:=false;
//copyBM.Execute;
tablefrom.active:=true;
Table.active:=true;
 tablefrom.first;
 m:=TList.create;
logs.startProc('PackT','PackTable','4','',5);
while not tablefrom.Eof do
begin
if (tablefrom.fieldbyname('Type').asInteger<>-1) then
begin
logs.startProc('PackT','PackTable','fill',inttostr(m.count),15);
m.add(pointer(tablefrom.fieldbyname('N').asInteger));
logs.startProc('PackT','PackTable','fillN',tablefrom.fieldbyname('N').asString,15);
end;
tablefrom.next;
end;
logs.startProc('PackT','PackTable','6','',5);
m.Sort(pc);
if selected then
begin
 for i:=m.Count-1 downto 0 do
 begin
  j:=integer(m[i]);
  mo:=Cont.getModelObjectByID(j);
  if mo=nil then m.Delete(i)
  else
  if not (mo^.otype in [SPRID,PROID,NEWBPID,REPID,XLSID]) then
  m.Delete(i);
 end;
end;
m.Sort(pc);
for i:=0 to m.count-1 do
begin
logs.startProc('PackT','PackTable','7',inttostr(i),15);
repeat
table.append;
table.post;
if not(table.fieldbyname('N').asInteger=Integer(m[i])) then table.delete;
until table.fieldbyname('N').asInteger=Integer(m[i]);
tablefrom.locate('N',Integer(m[i]),[]);
table.edit;
for j:=0 to tablefrom.fieldcount-1 do
if not (table.fields[j] is TAutoIncField) then
begin
logs.startProc('PackT','PackTable','71',table.fields[j].FullName,25);
table.fields[j].value:=tablefrom.fields[j].value;
if table.fields[j] is TStringField then
begin
TStringField(table.fields[j]).transliterate:=false;
//TStringField(tablefrom.fields[j]).transliterate:=false;
end;
end;
table.post;
end;
m.free;
logs.startProc('PackT','PackTable','8','',5);
tablefrom.active:=false;
  if not Table.Active then _DBError(SDataSetClosed);
  Check(DbiGetCursorProps(Table.Handle, FCurProp));
  if StrComp(FCurProp.szTableType, szParadox) = 0 then begin
    { Call DbiDoRestructure procedure if PARADOX table }
    hDb := nil;
    { Initialize the table descriptor }
    FillChar(TblDesc, SizeOf(CRTblDesc), 0);
    with TblDesc do begin
      { Place the table name in descriptor }
      StrPCopy(szTblName, Table.TableName);
      { Place the table type in descriptor }
      StrCopy(szTblType, FCurProp.szTableType);
    end;
    { Get the current table's directory. This is why the table MUST be
      opened until now }
logs.startProc('PackT','PackTable','81','',7);
    Check(DbiGetDirectory(Table.DBHandle, False, TablePath));
{tp:=extractfilepath(Table.tablename);
for i:=1 to length(tp) do
tablepath[i-1]:=tp[i];
tablepath[i-1]:=#0;}
    { Close the table }
    Table.Close;
logs.startProc('PackT','PackTable','9','',5);
    try
      { NOW: since the DbiDoRestructure call needs a valid DB handle BUT the
        table cannot be opened, call DbiOpenDatabase to get a valid handle.
        Setting TTable.Active = False does not give you a valid handle }
      Check(DbiOpenDatabase(nil, szCFGDBSTANDARD, dbiReadWrite, dbiOpenExcl, nil,
        0, nil, nil, hDb));
      { Set the table's directory to the old directory }
logs.startProc('PackT','PackTable','91','',7);
      Check(DbiSetDirectory(hDb, TablePath));
logs.startProc('PackT','PackTable','92','',7);
      { Pack the PARADOX table }
      TblDesc.bPack:=true;
      Check(DbiDoRestructure(hDb, 1, @TblDesc, pChar(SaveAs), nil, nil, false));
logs.startProc('PackT','PackTable','93','',7);
      { Close the temporary database handle }
      Check(DbiCloseDatabase(hDb));
logs.startProc('PackT','PackTable','94','',7);
    finally
      { Re-Open the table }

//      Table.Open;
    end;
  end
  else if StrComp(FCurProp.szTableType, szDBase) = 0 then begin
    { Call DbiPackTable procedure if dBase table }
    Exclusive := Table.Exclusive;
    Table.Close;
    try
      Table.Exclusive := True;
      Table.Open;
      try
        Check(DbiPackTable(Table.DBHandle, Table.Handle, nil, nil, True));
      finally
        Table.Close;
      end;
    finally
      Table.Exclusive := Exclusive;
      Table.Close;
    end;
  end
  else DbiError(DBIERR_WRONGDRVTYPE);
finally
table.free;
copyBM.free;
end;
logs.startProc('PackT','PackTable','10','finished',5);
end;

procedure AddType(Table: TTable);
  var  Props: CURProps;  hDb: hDBIDb;
  TableDesc: CRTblDesc;
  begin
  Table.Close;
  Table.Exclusive:=true;
  Table.Active:=true;
    // Make sure the table is open exclusively so we can get the db handle...
  if Table.Active = False then
    raise EDatabaseError.Create('Table must be opened to restructure');
  if Table.Exclusive = False then
    raise EDatabaseError.Create('Table must be opened exclusively to restructure');
  // Get the table properties to determine table type...
  Check(DbiGetCursorProps(Table.Handle, Props));
  // If the table is a Paradox table, you must call DbiDoRestructure...
  if Props.szTableType = szPARADOX then
     begin    // Blank out the structure...
    FillChar(TableDesc, sizeof(TableDesc), 0);
    //  Get the database handle from the table's cursor handle...
    Check(DbiGetObjFromObj(hDBIObj(Table.Handle), objDATABASE, hDBIObj(hDb)));
    // Put the table name in the table descriptor...
    StrPCopy(TableDesc.szTblName, Table.TableName);
    // Put the table type in the table descriptor...
    StrPCopy(TableDesc.szTblType, Props.szTableType);
    // Set the Pack option in the table descriptor to TRUE...
    TableDesc.bPack := True;
    // Close the table so the restructure can complete...
       Table.Close;
    // Call DbiDoRestructure...
    Check(DbiDoRestructure(hDb, 1, @TableDesc, nil, nil, nil, FALSE));
      Table.Active:=false;
      Table.Exclusive:=false;
      Table.Active:=true;
      end
  else    // If the table is a dBASE table, simply call DbiPackTable...
    if Props.szTableType = szDBASE then
      Check(DbiPackTable(Table.DBHandle, Table.Handle, nil, szDBASE, TRUE))
    else      // Pack only works on PAradox or dBASE; nothing else...
     raise EDatabaseError.Create('Table must be either of Paradox or dBASE ' +
               'type to pack');
    Table.Open;
             end;

end.
