unit StyleFormUnit;
{
(c) . . , .   1997,2006
}
{$INCLUDE Compmode.inc}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ToolWin, ComCtrls, StdCtrls, ExtCtrls, OleCtrls, SHDocVw, ColorGrd,
  Spin, ImgList,StyleDef,StyleStr, SHDocVw_TLB;

type
TNodeModify= procedure(p:PStyleRecord) of Object;
  TStyleForm = class(TForm)
    WebBrowser1: TWebBrowser;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet5: TTabSheet;
    FontEnabled: TCheckBox;
    FontSizeEnabled: TCheckBox;
    FontWeightEnabled: TCheckBox;
    FontStyleEnabled: TCheckBox;
    FontDialog1: TFontDialog;
    FontColorEnabled: TCheckBox;
    BackColorEnabled: TCheckBox;
    FontName: TComboBox;
    FontSize: TComboBox;
    FontSizeUnits: TComboBox;
    FontWeight: TComboBox;
    FontStyle: TComboBox;
    FontColorButton: TButton;
    BackColorButton: TButton;
    TextIndentEnabled: TCheckBox;
    TextIndent: TSpinEdit;
    VerticalAlignEnabled: TCheckBox;
    TextAlignEnabled: TCheckBox;
    VerticalAlign: TComboBox;
    TextAlign: TComboBox;
    LeftBorder: TComboBox;
    RightBorder: TComboBox;
    TopBorder: TComboBox;
    BottomBorder: TComboBox;
    LeftBorderEnabled: TCheckBox;
    RightBorderEnabled: TCheckBox;
    TopBorderEnabled: TCheckBox;
    BottomBorderEnabled: TCheckBox;
    FontColorDialog: TColorDialog;
    TreeView: TTreeView;
    ButtonImageList: TImageList;
    SaveDialog: TSaveDialog;
    Panel1: TPanel;
    OKButton: TButton;
    CancelButton: TButton;
    Splitter2: TSplitter;
    ShowServiceSimbols: TCheckBox;
    StyleName: TEdit;
    Label1: TLabel;
    TabSheet2: TTabSheet;
    WhiteSpaceEnabled: TCheckBox;
    WhiteSpace: TComboBox;
    MarksEnabled: TCheckBox;
    MarksType: TComboBox;
    PBBEnabled: TCheckBox;
    PageBreakBefore: TComboBox;
    PBAEnabled: TCheckBox;
    PageBreakAfter: TComboBox;
    TextDecorationEnabled: TCheckBox;
    TextTransformEnabled: TCheckBox;
    FontDecoration: TComboBox;
    FontTransform: TComboBox;
    LetterSpacingEnabled: TCheckBox;
    LetterSpacing: TSpinEdit;
    WordSpacingEnabled: TCheckBox;
    WordSpacing: TSpinEdit;
    LeftMarginEnabled: TCheckBox;
    LeftMargin: TSpinEdit;
    LeftMarginUnits: TComboBox;
    RightMarginEnabled: TCheckBox;
    RightMargin: TSpinEdit;
    RightMarginUnits: TComboBox;
    BottomMarginEnabled: TCheckBox;
    BottomMargin: TSpinEdit;
    BottomMarginUnits: TComboBox;
    TopMarginEnabled: TCheckBox;
    TopMargin: TSpinEdit;
    TopMarginUnits: TComboBox;
    procedure FontColorButtonClick(Sender: TObject);
    procedure BackColorButtonClick(Sender: TObject);
    procedure QuitItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FontEnabledClick(Sender: TObject);
    procedure FontSizeEnabledClick(Sender: TObject);
    procedure FontWeightEnabledClick(Sender: TObject);
    procedure FontStyleEnabledClick(Sender: TObject);
    procedure TextDecorationEnabledClick(Sender: TObject);
    procedure TextTransformEnabledClick(Sender: TObject);
    procedure FontColorEnabledClick(Sender: TObject);
    procedure BackColorEnabledClick(Sender: TObject);
    procedure TextIndentEnabledClick(Sender: TObject);
    procedure WordSpacingEnabledClick(Sender: TObject);
    procedure LetterSpacingEnabledClick(Sender: TObject);
    procedure VerticalAlignEnabledClick(Sender: TObject);
    procedure TextAlignEnabledClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeViewEditing(Sender: TObject; Node: TTreeNode;
      var AllowEdit: Boolean);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure SaveButtonClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FontNameChange(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure FontSizeUnitsChange(Sender: TObject);
    procedure FontWeightChange(Sender: TObject);
    procedure FontStyleChange(Sender: TObject);
    procedure FontDecorationChange(Sender: TObject);
    procedure FontTransformChange(Sender: TObject);
    procedure TextIndentChange(Sender: TObject);
    procedure WordSpacingChange(Sender: TObject);
    procedure LetterSpacingChange(Sender: TObject);
    procedure VerticalAlignChange(Sender: TObject);
    procedure TextAlignChange(Sender: TObject);
    procedure LeftMarginEnabledClick(Sender: TObject);
    procedure RightMarginEnabledClick(Sender: TObject);
    procedure BottomMarginEnabledClick(Sender: TObject);
    procedure TopMarginEnabledClick(Sender: TObject);
    procedure LeftBorderEnabledClick(Sender: TObject);
    procedure RightBorderEnabledClick(Sender: TObject);
    procedure TopBorderEnabledClick(Sender: TObject);
    procedure BottomBorderEnabledClick(Sender: TObject);
    procedure LeftMarginChange(Sender: TObject);
    procedure RightMarginChange(Sender: TObject);
    procedure BottomMarginChange(Sender: TObject);
    procedure TopMarginChange(Sender: TObject);
    procedure LeftMarginUnitsChange(Sender: TObject);
    procedure LeftBorderChange(Sender: TObject);
    procedure RightMarginUnitsChange(Sender: TObject);
    procedure BottomMarginUnitsChange(Sender: TObject);
    procedure TopMarginUnitsChange(Sender: TObject);
    procedure RightBorderChange(Sender: TObject);
    procedure TopBorderChange(Sender: TObject);
    procedure BottomBorderChange(Sender: TObject);
    procedure MarksEnabledClick(Sender: TObject);
    procedure PBBEnabledClick(Sender: TObject);
    procedure PBAEnabledClick(Sender: TObject);
    procedure MarksTypeChange(Sender: TObject);
    procedure PageBreakBeforeChange(Sender: TObject);
    procedure PageBreakAfterChange(Sender: TObject);
    procedure WhiteSpaceEnabledClick(Sender: TObject);
    procedure WhiteSpaceChange(Sender: TObject);
    procedure HelpItemClick(Sender: TObject);
    procedure CreateButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ShowServiceSimbolsClick(Sender: TObject);
    procedure StyleNameChange(Sender: TObject);
    procedure SaveDialogCanClose(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    FRoot:PStyleRecord;
    Fstream:TStyleStream;
    FUpdating:boolean;
    OleV:OleVariant;
    procedure ProcessNodes(node:TTreeNode;Processor:TNodeModify);
    procedure GetFontNames;
    procedure SetModified( Value:Boolean );
    procedure PageSettingChanged( Value:Boolean );
    function  QuerySave:Boolean;
    procedure SetState(Value:Boolean);
    procedure GenerateHTML(stylename:string);
    function  ColorToWeb(Value:TColor):String;
    function  StrToCSSName(Value:String):String;
    procedure ShowHTML(stylename:string);
  public
    { Public declarations }
    FModified:Boolean;
    FFileName:String;
    FontColor:TColor;
    BackColor:TColor;
    PageSetting:Boolean;
    FState:Boolean;
    FOpenTable:Boolean;
    FShow:Boolean;
    strNode,posNode,ClsNode,PrNode,InvPrNode:TTreeNode;    
    procedure OpenCSSTable(FileName:String);
  end;

var
  StyleForm: TStyleForm;

function  EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;

Const formname='   ';

implementation


{$R *.DFM}
uses appconst;
procedure TStyleForm.ShowHTML(stylename:string);
 begin
   if FShow then Exit;
   FShow:=True;
   WebBrowser1.Navigate('about:blank',oleV);

  // while WebBrowser1.Busy=True do    application.processMessages;
    GenerateHTML(stylename);
   WebBrowser1.Navigate(ExtractFilePath(Application.ExeName)+'tmp.htm',OleV);
  // while WebBrowser1.Busy=True do    application.processMessages;
   FShow:=False;
 end;

function  TStyleForm.StrToCSSName(Value:String):String;
Var len,i:Integer;
 begin
   Result:='';
   len:=Length(Value);
   if len=0 then Exit;
   if Value[1]='@' then
       begin
          Result:=Value;
          Exit;
       end;
   for i:=1 to len do
    begin
     if (Value[i]<>' ') then
      Result:=Result+Value[i]
     else
      Result:=Result+'_';
    end;
 end;

function  TStyleForm.ColorToWeb(Value:TColor):String;
Var r,g,b,a:DWORD;
 begin
   Result:='#';
   r:=(DWORD(Value) shr 16) and $FF;
   g:=(DWORD(Value) shr 8) and $FF;
   b:=DWORD(VALUE) and $FF;
   a:=r or (g shl 8) or (b shl 16);
   Result:=Result+IntToHex(a,6);
 end;

procedure TStyleForm.GenerateHTML(stylename:string);
var list:TStringList;
    p:PStyleRecord;
    s:String;
 begin
   p:=PStyleRecord(TreeView.Selected.Data);
   if p=nil then Exit;
   list:=TStringList.Create;
   list.Add('<HTML>');
   list.Add('<HEAD>');
   list.add('<meta http-equiv="Content-Type" content="text/html; charset=WINDOWS-1251">');
   list.Add('<STYLE>');
   if (p^.StyleName<>'@page') then
    list.Add('#'+StrToCSSName(p^.StyleName)+' {')
   else
    list.Add(p^.StyleName+' {');
   if p^.FontEnabled then
     list.Add('font-family : "'+p^.Font+'";');
   case (p^.FontSizeUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
    else s:='pt';
   end;
   if p^.FontSizeEnabled then
     list.Add('font-size : '+IntToStr(p^.FontSize)+s+';');
   case (p^.FontWeight) of
    fwExtraLight:  s:='extra-light';
    fwLight:       s:='light';
    fwDemiLight:   s:='demi-light';
    fwMedium:      s:='medium';
    fwDemiBold:    s:='demi-bold';
    fwBold:        s:='bold';
    fwExtraBold:   s:='extra-bold';
    fwBorder:      s:='border';
    fwLighter:     s:='lighter';
    else s:='fwExtraLight';
   end;
   if p^.FontWeightEnabled then
     list.Add('font-weight : '+s+';');
   case (p^.FontStyle) of
     fsItalic:      s:='italic';
     fsOblique:     s:='oblique';
     fsSmallCaps:   s:='small-caps';
     fsNone:        s:='none';
     else s:='none';
   end;
   if p^.FontStyleEnabled then
     list.Add('font-style : '+s+';');
   case (p^.TextDecoration) of
    tdUnderline:    s:='underline';
    tdOverline:     s:='overline';
    tdLineThrough:  s:='line-through';
    tdBlink:        s:='blink';
    tdNone:         s:='none';
    else s:='none';
   end;
   if p^.TextDecorationEnabled then
     list.Add('text-decoration : '+s+';');
   case (p^.TextTransform) of
    ttCapitalize:    s:='capitalize';
    ttUppercase:     s:='uppercase';
    ttLowercase:     s:='lowercase';
    ttNone:          s:='none';
    else s:='none';
   end;
   if p^.TextTransformEnabled then
     list.Add('text-transform : '+s+';');
   if p^.FontColorEnabled then
     list.Add('color : '+ColorToWeb(TColor(p^.FontColor))+';');
   if p^.BackColorEnabled then
     list.Add('background : '+ColorToWeb(TColor(p^.BackColor))+';');
   if p^.TextIndentEnabled then
     list.Add('text-indent : '+IntToStr(p^.TextIndent)+'pt;');
   {if p^.LeadingSpaceEnabled then
     list.Add('margin-left : '+IntToStr(p^.LeadingSpace)+'pt;');}
   if p^.WordSpacingEnabled then
     list.Add('word-spacing : '+IntToStr(p^.WordSpacing)+'pt;');
   if p^.LetterSpacingEnabled then
     list.Add('letter-spacing : '+IntToStr(p^.LetterSpacing)+'pt;');
   case (p^.VerticalAlign) of
     vaBaseline:   s:='baseline';
     vaBottom:     s:='bottom';
     vaMiddle:     s:='middle';
     vaSub:        s:='sub';
     vaSuper:      s:='super';
     vaTextBottom: s:='text-bottom';
     vaTextTop:    s:='text-top';
     vaTop:        s:='top';
     else s:='baseline';
   end;
   if p^.VerticalAlignEnabled then
     list.Add('verical-align : '+s+';');
   case (p^.TextAlign) of
     taCenter:     s:='center';
     taJustify:    s:='justify';
     taLeft:       s:='left';
     taRight:      s:='right';
     else s:='left';
   end;
   if p^.TextAlignEnabled then
     list.Add('text-align : '+s+';');
   case (p^.LeftMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
    else s:='pt';
   end;
   if p^.LeftMarginEnabled then
     list.Add('margin-left : '+IntToStr(p^.LeftMargin)+s+';');
   case (p^.RightMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
    else s:='pt';
   end;
   if p^.RightMarginEnabled then
     list.Add('margin-right : '+IntToStr(p^.RightMargin)+s+';');
   case (p^.TopMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
    else s:='pt';
   end;
   if p^.TopMarginEnabled then
     list.Add('margin-top : '+IntToStr(p^.TopMargin)+s+';');
   case (p^.BottomMarginUnits) of
    fsuPt: s:='pt';
    fsuIn: s:='in';
    fsuMm: s:='mm';
    fsuCm: s:='cm';
    fsuPc: s:='pc';
    fsuPx: s:='px';
    fsuEm: s:='em';
    fsuEx: s:='ex';
    else s:='pt';
   end;
   if p^.BottomMarginEnabled then
     list.Add('margin-bottom : '+IntToStr(p^.BottomMargin)+s+';');
   case (p^.LeftBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
    else s:='none';
   end;
   if p^.LeftBorderEnabled then
     list.Add('border-left : '+s+';');
   case (p^.RightBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
    else s:='none';
   end;
   if p^.RightBorderEnabled then
     list.Add('border-right : '+s+';');
   case (p^.TopBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
    else s:='none';
   end;
   if p^.TopBorderEnabled then
     list.Add('border-top : '+s+';');
   case (p^.BottomBorder) of
    btDotted:    s:='dotted';
    btDashed:    s:='dashed';
    btSolid:     s:='solid';
    btDouble:    s:='double';
    btGroove:    s:='groove';
    btRidge:     s:='ridge';
    btInset:     s:='inset';
    btOutset:    s:='outset';
    btNone:      s:='none';
    else s:='none';
   end;
   if p^.BottomBorderEnabled then
     list.Add('border-bottom : '+s+';');
   case (p^.MarksType) of
    mtCrop:   s:='crop';
    mtCross:  s:='cross';
    mtNone:   s:='none';
    else s:='none';
   end;
   if p^.MarksEnabled then
     list.Add('marks : '+s+';');
   case (p^.orientation) of
     orAuto:        s:='auto';
     orLandscape:   s:='landscape';
     orPortrait:    s:='portrait';
     else s:='auto';
   end;
   if p^.OrientationEnabled then
     list.Add('size : '+s+';');
   case (p^.PageBreakBefore) of
     pbAlways:      s:='always';
     pbAuto:        s:='auto';
     pbLeft:        s:='left';
     pbRight:       s:='right';
     else s:='auto';
   end;
   if p^.PBBEnabled then
     list.Add('page-break-before : '+s+';');
   case (p^.PageBreakAfter) of
     pbAlways:      s:='always';
     pbAuto:        s:='auto';
     pbLeft:        s:='left';
     pbRight:       s:='right';
     else s:='auto';
   end;
   if p^.PBAEnabled then
     list.Add('page-break-after : '+s+';');
   case (p^.ListStyle) of
     lsDisc:         s:='disc';
     lsCircle:       s:='circle';
     lsSquare:       s:='square';
     lsDecimal:      s:='decimal';
     lsLowerRoman:   s:='lower-roman';
     lsUpperRoman:   s:='upper-roman';
     lsLowerAlpha:   s:='lower-alpha';
     lsUpperAlpha:   s:='upper-alpha';
     lsNone:         s:='none';
     else s:='none';
   end;
   if p^.ListStyleEnabled then
     list.Add('list-style : '+s+';');
   case (p^.WhiteSpace) of
    wsPre:        s:='pre';
    wsNowrap:     s:='nowrap';
    wsNormal:     s:='normal';
    else s:='normal';
   end;
   if p^.WhiteSpaceEnabled then
     list.Add('white-space : '+s+';');
   list.Add('}');
   list.Add('</STYLE>');
   list.Add('</HEAD>');
   list.Add('<BODY>');
   if p^.ListStyleEnabled then list.Add('<UL>');
   list.Add('<P ID='+StrToCSSName(p^.StyleName)+'>');
   if p^.ListStyleEnabled then
    begin
     list.Add('<LI ID='+StrToCSSName(p^.StyleName)+'>  :'+stylename);
    end
   else list.Add('  :'+stylename);
   list.Add('</P>');
   if p^.ListStyleEnabled then list.Add('</UL>');
   list.Add('</BODY>');
   list.Add('</HTML>');
   list.SaveToFile(ExtractFilePath(Application.ExeName)+'tmp.htm');
   list.Clear;
   list.Free;
 end;

procedure TStyleForm.PageSettingChanged( Value:Boolean );
 begin
   MarksEnabled.Enabled:=Value and FState;
   PBBEnabled.Enabled:=Value and FState;
   PBAEnabled.Enabled:=Value and FState;
 end;

procedure TStyleForm.SetState(Value:Boolean);
 begin
   FState:=Value;
   FontEnabled.Enabled:=Value;
   FontSizeEnabled.Enabled:=Value;
   FontWeightEnabled.Enabled:=Value;
   FontStyleEnabled.Enabled:=Value;
   TextDecorationEnabled.Enabled:=Value;
   TextTransformEnabled.Enabled:=Value;
   FontColorEnabled.Enabled:=Value;
   BackColorEnabled.Enabled:=Value;
   TextIndentEnabled.Enabled:=Value;
   WordSpacingEnabled.Enabled:=Value;
   LetterSpacingEnabled.Enabled:=Value;
   VerticalAlignEnabled.Enabled:=Value;
   TextAlignEnabled.Enabled:=Value;
   LeftMarginEnabled.Enabled:=Value;
   RightMarginEnabled.Enabled:=Value;
   TopMarginEnabled.Enabled:=Value;
   BottomMarginEnabled.Enabled:=Value;
   LeftBorderEnabled.Enabled:=Value;
   RightBorderEnabled.Enabled:=Value;
   TopBorderEnabled.Enabled:=Value;
   BottomBorderEnabled.Enabled:=Value;
   MarksEnabled.Enabled:=Value and PageSetting;
   PBBEnabled.Enabled:=Value and PageSetting;
   PBAEnabled.Enabled:=Value and PageSetting;
   WhiteSpaceEnabled.Enabled:=Value;
 end;

function TStyleForm.QuerySave:Boolean;
Var hr:Integer;
    s,s1:String;
 begin
   Result:=True;
   if FModified=False then Exit;
   s1:='  ';
   s:='  ?';
   hr:=Application.MessageBox(PChar(s),PChar(s1),MB_OKCANCEL);
   if hr=IDOK then
    begin
      SaveButtonClick(self);
      Exit;
    end;
   Result:=False;
 end;

procedure TStyleForm.SetModified(Value:Boolean);
 begin
  if FUpdating then exit;
   FModified:=Value;

   OKButton.Enabled:=Value;
   if (Value and (not(FOpenTable))) then
   begin
    ShowHTML(treeview.selected.text);
   end;
 end;

procedure TStyleForm.OpenCSSTable(FileName:String);
Var p:PStyleRecord;
    node:TTreeNode;
    i:integer;
    firstnode:TTreeNode;
 begin
  {}
  FOpenTable:=True;
  SetState(True);
  FFileName:=FileName;
  strNode.DeleteChildren;
  PosNode.DeleteChildren;
  ClsNode.DeleteChildren;
  PrNode.DeleteChildren;
  InvPrNode.DeleteChildren;
  try
  FStream.OpenStream(FileName,stRead);
  froot:=nil;
  FStream.ReadStream(FRoot);
  finally
  FStream.CloseStream;
  end;
  p:=FRoot;
  i:=0;
  while (p<>nil) do
   begin
   node:=nil;
     case i of
     0..7:node:=TreeView.Items.AddChild(strNode,p^.StyleName);
     8..22:node:=TreeView.Items.AddChild(clsNode,p^.StyleName);
     23..37:node:=TreeView.Items.AddChild(invPrNode,p^.StyleName);
     38:node:=TreeView.Items.AddChild(strNode,p^.StyleName);
     39..40:node:=TreeView.Items.AddChild(posNode,p^.StyleName);
     41..43:node:=TreeView.Items.AddChild(strNode,p^.StyleName);
     44:node:=TreeView.Items.AddChild(posNode,p^.StyleName);
     45..56:node:=TreeView.Items.AddChild(prNode,p^.StyleName);
     57:node:=TreeView.Items.AddChild(strNode,p^.StyleName);
     58:begin
        node:=TreeView.Items[0];
        p^.StyleName:=node.text;
        firstnode:=node;
        end;
     59:;
     60:node:=TreeView.Items.AddChild(strNode,p^.StyleName);
     61..62:;
     else node:=TreeView.Items.AddChild(strNode,p^.StyleName);
end;
if node<>nil then
node.Data:=Pointer(p);
    inc(i);

     p:=p^.Next;
   end;
   TreeView.FullCollapse;
   TreeView.selected:=firstnode;
   SetModified(False);
   FOpenTable:=False;
   FUpdating:=false;
 end;

procedure TStyleForm.FontColorButtonClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  FontColorDialog.Color:=FontColor;
  if FontColorDialog.Execute then
   begin
    FontColor:=FontColorDialog.Color;
    if p<>nil then p^.FontColor:=FontColor;
    SetModified(True);
   end;
end;

procedure TStyleForm.BackColorButtonClick(Sender: TObject);
Var p:PStyleRecord;
begin
 p:=PStyleRecord(TreeView.Selected.Data);
 FontColorDialog.Color:=BackColor;
 if FontColorDialog.Execute then
  begin
   BackColor:=FontColorDialog.Color;
   if p<>nil then p^.BackColor:=BackColor;
   SetModified(True);
  end;
end;

procedure TStyleForm.QuitItemClick(Sender: TObject);
begin
 Close;
end;

procedure TStyleForm.GetFontNames;
var
  DC: HDC;
begin
  DC := GetDC(0);
  EnumFonts(DC, nil, @EnumFontsProc, Pointer(FontName.Items));
  ReleaseDC(0, DC);
  FontName.Sorted := True;
end;

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
begin
  TStrings(Data).Add(LogFont.lfFaceName);
  Result := 1;
end;

procedure TStyleForm.FormCreate(Sender: TObject);
begin
OleV:=navNoHistory+navNoReadFromCache+navNoWriteToCache;
 FOpenTable:=False;
 FShow:=False;
 PageSetting:=False;
 FState:=False;
 SetState(False);
 SetModified(False);
 PageControl1.ActivePage:=TabSheet1;
 GetFontNames;
 FStream:=TStyleStream.Create;
 FFileName:='';
 Caption:=formname;
strNode:=TreeView.items[1];
posNode:=TreeView.items[2];
ClsNode:=TreeView.items[3];
PrNode:=TreeView.items[4];
InvPrNode:=TreeView.items[5];
    OpenCSSTable('Master\temp.afm');
SaveDialog.InitialDir:=appconst.sysinfo.folders.AFMFolder;
end;

procedure TStyleForm.FontEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
 p:=PStyleRecord(TreeView.Selected.Data);
 FontName.Enabled:=FontEnabled.Checked;
 p^.FontEnabled:=FontEnabled.Checked;

 SetModified(True);
end;

procedure TStyleForm.FontSizeEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  FontSize.Enabled:=FontSizeEnabled.Checked;
  FontSizeUnits.Enabled:=FontSizeEnabled.Checked;
  p^.FontSizeEnabled:=FontSizeEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.FontWeightEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  FontWeight.Enabled:=FontWeightEnabled.Checked;
  p^.FontWeightEnabled:=FontWeightEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.FontStyleEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  FontStyle.Enabled:=FontStyleEnabled.Checked;
  p^.FontStyleEnabled:=FontStyleEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.TextDecorationEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
 p:=PStyleRecord(TreeView.Selected.Data);
 FontDecoration.Enabled:=TextDecorationEnabled.Checked;
 p^.TextDecorationEnabled:=TextDecorationEnabled.Checked;
 SetModified(True);
end;

procedure TStyleForm.TextTransformEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  FontTransform.Enabled:=TextTransformEnabled.Checked;
  p^.TextTransformEnabled:=TextTransformEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.FontColorEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  FontColorButton.Enabled:=FontColorEnabled.Checked;
  p^.FontColorEnabled:=FontColorEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.BackColorEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  BackColorButton.Enabled:=BackColorEnabled.Checked;
  p^.BackColorEnabled:=BackColorEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.TextIndentEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
 p:=PStyleRecord(TreeView.Selected.Data);
 TextIndent.Enabled:=TextIndentEnabled.Checked;
 p^.TextIndentEnabled:=TextIndentEnabled.Checked;
 SetModified(True);
end;


procedure TStyleForm.WordSpacingEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
 p:=PStyleRecord(TreeView.Selected.Data);
 WordSpacing.Enabled:=WordSpacingEnabled.Checked;
 p^.WordSpacingEnabled:=WordSpacingEnabled.Checked;
 SetModified(True);
end;

procedure TStyleForm.LetterSpacingEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
 p:=PStyleRecord(TreeView.Selected.Data);
 LetterSpacing.Enabled:=LetterSpacingEnabled.Checked;
 p^.LetterSpacingEnabled:=LetterSpacingEnabled.Checked;
 SetModified(True);
end;

procedure TStyleForm.VerticalAlignEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
 p:=PStyleRecord(TreeView.Selected.Data);
 VerticalAlign.Enabled:=VerticalAlignEnabled.Checked;
 p^.VerticalAlignEnabled:=VerticalAlignEnabled.Checked;
 SetModified(True);
end;

procedure TStyleForm.TextAlignEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  TextAlign.Enabled:=TextAlignEnabled.Checked;
  p^.TextAlignEnabled:=TextAlignEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.FormDestroy(Sender: TObject);
begin
  FStream.ClearCSSList(FRoot);
  TreeView.Items.Clear;
  FStream.Destroy;
end;

procedure TStyleForm.TreeViewEditing(Sender: TObject; Node: TTreeNode;
  var AllowEdit: Boolean);
begin
 AllowEdit:=False;
end;

procedure TStyleForm.TreeViewChange(Sender: TObject; Node: TTreeNode);
Var p:PStyleRecord;
begin
PageControl1.enabled:=false;
if node=nil then exit;
  p:=PStyleRecord(Node.Data);

  if p=nil then Exit;
PageControl1.enabled:=true;
  if (p^.StyleName='@page') then
    PageSetting:=True else PageSetting:=False;
  PageSettingChanged(PageSetting);
  fUpdating:=true;
  FontEnabled.Checked:=p^.FontEnabled;
  FontName.Text:=p^.Font;
  FontSizeEnabled.Checked:=p^.FontSizeEnabled;
  FontSize.Text:=IntToStr(p^.FontSize);
  FontSizeUnits.Text:=FontSizeUnits.Items.Strings[Integer(p^.FontSizeUnits)];
  FontWeightEnabled.Checked:=p^.FontWeightEnabled;
  FontWeight.Text:=FontWeight.Items.Strings[Integer(p^.FontWeight)];
  FontStyleEnabled.Checked:=p^.FontStyleEnabled;
  FontStyle.Text:=FontStyle.Items.Strings[Integer(p^.FontStyle)];
  TextDecorationEnabled.Checked:=p^.TextDecorationEnabled;
  FontDecoration.Text:=FontDecoration.Items.Strings[Integer(p^.TextDecoration)];
  TextTransformEnabled.Checked:=p^.TextTransformEnabled;
  FontTransform.Text:=FontTransform.Items.Strings[Integer(p^.TextTransform)];
  FontColor:=TColor(p^.FontColor);
  FontColorEnabled.Checked:=p^.FontColorEnabled;
  BackColor:=TColor(p^.BackColor);
  BackColorEnabled.Checked:=p^.BackColorEnabled;
  TextIndentEnabled.Checked:=p^.TextIndentEnabled;
  TextIndent.Value:=p^.TextIndent;
  WordSpacingEnabled.Checked:=p^.WordSpacingEnabled;
  WordSpacing.Value:=p^.WordSpacing;
  LetterSpacingEnabled.Checked:=p^.LetterSpacingEnabled;
  LetterSpacing.Value:=p^.LetterSpacing;
  VerticalAlignEnabled.Checked:=p^.VerticalAlignEnabled;
  VerticalAlign.Text:=VerticalAlign.Items.Strings[Integer(p^.VerticalAlign)];
  TextAlignEnabled.Checked:=p^.TextAlignEnabled;
  TextAlign.Text:=TextAlign.Items.Strings[Integer(p^.TextAlign)];
  LeftMarginEnabled.Checked:=p^.LeftMarginEnabled;
  RightMarginEnabled.Checked:=p^.RightMarginEnabled;
  TopMarginEnabled.Checked:=p^.TopMarginEnabled;
  BottomMarginEnabled.Checked:=p^.BottomMarginEnabled;
  LeftBorderEnabled.Checked:=p^.LeftBorderEnabled;
  RightBorderEnabled.Checked:=p^.RightBorderEnabled;
  TopBorderEnabled.Checked:=p^.TopBorderEnabled;
  BottomBorderEnabled.Checked:=p^.BottomBorderEnabled;
  LeftMargin.Value:=p^.LeftMargin;
  RightMargin.Value:=p^.RightMargin;
  TopMargin.Value:=p^.TopMargin;
  BottomMargin.Value:=p^.BottomMargin;
  LeftMarginUnits.Text:=LeftMarginUnits.Items.Strings[Integer(p^.LeftMarginUnits)];
  RightMarginUnits.Text:=RightMarginUnits.Items.Strings[Integer(p^.RightMarginUnits)];
  TopMarginUnits.Text:=TopMarginUnits.Items.Strings[Integer(p^.TopMarginUnits)];
  BottomMarginUnits.Text:=BottomMarginUnits.Items.Strings[Integer(p^.BottomMarginUnits)];
  LeftBorder.Text:=LeftBorder.Items.Strings[Integer(p^.LeftBorder)];
  RightBorder.Text:=RightBorder.Items.Strings[Integer(p^.RightBorder)];
  TopBorder.Text:=TopBorder.Items.Strings[Integer(p^.TopBorder)];
  BottomBorder.Text:=BottomBorder.Items.Strings[Integer(p^.BottomBorder)];
  WhiteSpaceEnabled.Checked:=p^.WhiteSpaceEnabled;
  WhiteSpace.Text:=WhiteSpace.Items.Strings[Integer(p^.WhiteSpace)];
  ShowServiceSimbols.checked :=p^.flags and 1 =1;
  StyleName.enabled:=false;
  StyleName.text:=p^.StyleName;
  StyleName.enabled:=true;
  ShowHTML(treeview.selected.text);
  fUpdating:=false;
end;

procedure TStyleForm.SaveButtonClick(Sender: TObject);
begin
  FStream.OpenStream(FFileName,stWrite);
  FStream.WriteStream(FRoot);
  FStream.CloseStream;
  SetModified(False);
  close;
end;

procedure TStyleForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  QuerySave;
  CanClose:=True;
end;

procedure TStyleForm.FontNameChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.Font:=FontName.Text;
  SetModified(True);
end;

procedure TStyleForm.FontSizeChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.FontSize:=StrToIntDef(FontSize.Text,10);
  SetModified(True);
end;

procedure TStyleForm.FontSizeUnitsChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.FontSizeUnits:=TFontSizeUnits(FontSizeUnits.Items.IndexOf(FontSizeUnits.Text));
  SetModified(True);
end;

procedure TStyleForm.FontWeightChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.FontWeight:=TFontWeight(FontWeight.Items.IndexOf(FontWeight.Text));
  SetModified(True);
end;

procedure TStyleForm.FontStyleChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.FontStyle:=TFontStyle(FontStyle.Items.IndexOf(FontStyle.Text));
  SetModified(True);
end;

procedure TStyleForm.FontDecorationChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.TextDecoration:=TTextDecoration(FontDecoration.Items.IndexOf(FontDecoration.Text));
  SetModified(True);
end;

procedure TStyleForm.FontTransformChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.TextTransform:=TTextTransform(FontTransform.Items.IndexOf(FontTransform.Text));
  SetModified(True);
end;

procedure TStyleForm.TextIndentChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.TextIndent:=TextIndent.Value;
  SetModified(True);
end;


procedure TStyleForm.WordSpacingChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.WordSpacing:=WordSpacing.Value;
  SetModified(True);
end;

procedure TStyleForm.LetterSpacingChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.LetterSpacing:=LetterSpacing.Value;
  SetModified(True);
end;

procedure TStyleForm.VerticalAlignChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.VerticalAlign:=TVerticalAlign(VerticalAlign.Items.IndexOf(VerticalAlign.Text));
  SetModified(True);
end;

procedure TStyleForm.TextAlignChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.TextAlign:=TTextAlign(TextAlign.Items.IndexOf(TextAlign.Text));
  SetModified(True);
end;

procedure TStyleForm.LeftMarginEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  LeftMargin.Enabled:=LeftMarginEnabled.Checked;
  LeftMarginUnits.Enabled:=LeftMarginEnabled.Checked;
  p^.LeftMarginEnabled:=LeftMarginEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.RightMarginEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  RightMargin.Enabled:=RightMarginEnabled.Checked;
  RightMarginUnits.Enabled:=RightMarginEnabled.Checked;
  p^.RightMarginEnabled:=RightMarginEnabled.Checked;
  SetModified(True);

end;

procedure TStyleForm.BottomMarginEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  BottomMargin.Enabled:=BottomMarginEnabled.Checked;
  BottomMarginUnits.Enabled:=BottomMarginEnabled.Checked;
  p^.BottomMarginEnabled:=BottomMarginEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.TopMarginEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  TopMargin.Enabled:=TopMarginEnabled.Checked;
  TopMarginUnits.Enabled:=TopMarginEnabled.Checked;
  p^.TopMarginEnabled:=TopMarginEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.LeftBorderEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  LeftBorder.Enabled:=LeftBorderEnabled.Checked;
  p^.LeftBorderEnabled:=LeftBorderEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.RightBorderEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  RightBorder.Enabled:=RightBorderEnabled.Checked;
  p^.RightBorderEnabled:=RightBorderEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.TopBorderEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  TopBorder.Enabled:=TopBorderEnabled.Checked;
  p^.TopBorderEnabled:=TopBorderEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.BottomBorderEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  BottomBorder.Enabled:=BottomBorderEnabled.Checked;
  p^.BottomBorderEnabled:=BottomBorderEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.LeftMarginChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.LeftMargin:=LeftMargin.Value;
  SetModified(True);
end;

procedure TStyleForm.RightMarginChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.RightMargin:=RightMargin.Value;
  SetModified(True);
end;

procedure TStyleForm.BottomMarginChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.BottomMargin:=BottomMargin.Value;
  SetModified(True);
end;

procedure TStyleForm.TopMarginChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.TopMargin:=TopMargin.Value;
  SetModified(True);
end;

procedure TStyleForm.LeftMarginUnitsChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.LeftMarginUnits:=TFontSizeUnits(LeftMarginUnits.Items.IndexOf(LeftMarginUnits.Text));
  SetModified(True);
end;

procedure TStyleForm.LeftBorderChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.LeftBorder:=TBorderType(LeftBorder.Items.IndexOf(LeftBorder.Text));
  SetModified(True);
end;

procedure TStyleForm.RightMarginUnitsChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.RightMarginUnits:=TFontSizeUnits(RightMarginUnits.Items.IndexOf(RightMarginUnits.Text));
  SetModified(True);

end;

procedure TStyleForm.BottomMarginUnitsChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.BottomMarginUnits:=TFontSizeUnits(BottomMarginUnits.Items.IndexOf(BottomMarginUnits.Text));
  SetModified(True);

end;

procedure TStyleForm.TopMarginUnitsChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.TopMarginUnits:=TFontSizeUnits(TopMarginUnits.Items.IndexOf(TopMarginUnits.Text));
  SetModified(True);
end;

procedure TStyleForm.RightBorderChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.RightBorder:=TBorderType(RightBorder.Items.IndexOf(RightBorder.Text));
  SetModified(True);
end;

procedure TStyleForm.TopBorderChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.TopBorder:=TBorderType(TopBorder.Items.IndexOf(TopBorder.Text));
  SetModified(True);
end;

procedure TStyleForm.BottomBorderChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.BottomBorder:=TBorderType(BottomBorder.Items.IndexOf(BottomBorder.Text));
  SetModified(True);
end;

procedure TStyleForm.MarksEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  MarksType.Enabled:=MarksEnabled.Checked;
  p^.MarksEnabled:=MarksEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.PBBEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  PageBreakBefore.Enabled:=PBBEnabled.Checked;
  P^.PBBEnabled:=PBBEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.PBAEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  PageBreakAfter.Enabled:=PBAEnabled.Checked;
  P^.PBAEnabled:=PBAEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.MarksTypeChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.MarksType:=TMarksType(MarksType.Items.IndexOf(MarksType.Text));
  SetModified(True);
end;

procedure TStyleForm.PageBreakBeforeChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.PageBreakBefore:=TPageBreak(PageBreakBefore.Items.IndexOf(PageBreakBefore.Text));
  SetModified(True);
end;

procedure TStyleForm.PageBreakAfterChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.PageBreakAfter:=TPageBreak(PageBreakAfter.Items.IndexOf(PageBreakAfter.Text));
  SetModified(True);
end;


procedure TStyleForm.WhiteSpaceEnabledClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  WhiteSpace.Enabled:=WhiteSpaceEnabled.Checked;
  p^.WhiteSpaceEnabled:=WhiteSpaceEnabled.Checked;
  SetModified(True);
end;

procedure TStyleForm.WhiteSpaceChange(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.WhiteSpace:=TWhiteSpace(WhiteSpace.Items.IndexOf(WhiteSpace.Text));
  SetModified(True);
end;

procedure TStyleForm.HelpItemClick(Sender: TObject);
begin
 Application.HelpContext(0);
end;

procedure TStyleForm.CreateButtonClick(Sender: TObject);
begin
 QuerySave;
 SaveDialog.Title:='    '+ExtractFileName(FFileName);
 SaveDialog.InitialDir:=ExtractFilePath(Application.ExeName);
 if SaveDialog.Execute then
   begin
     FStream.OpenStream(SaveDialog.FileName,stWrite);
     FStream.WriteStream(FRoot);
     FStream.CloseStream;
     FFileName:=SaveDialog.FileName;
     SetModified(False);
     SetState(True);
     Caption:=formname+'['+ExtractFileName(FFileName)+']';
   end;
end;

procedure TStyleForm.FormActivate(Sender: TObject);
begin
strNode.Expand(false);
posnode.expand(false);
TreeView.Selected:=strNode.Item[0];
   ShowHTML(TreeView.selected.text);
end;

procedure TStyleForm.ShowServiceSimbolsClick(Sender: TObject);
Var p:PStyleRecord;
begin
  p:=PStyleRecord(TreeView.Selected.Data);
  p^.ShowSystemChars:=ShowServiceSimbols.checked;
  if ShowServiceSimbols.Checked then
  p^.flags:=p^.Flags or 1
  else
  p^.flags:=p^.flags and not 1;
  SetModified(True);

end;

procedure TStyleForm.StyleNameChange(Sender: TObject);
Var p:PStyleRecord;
begin
if not StyleName.enabled then exit;
 p:=PStyleRecord(TreeView.Selected.Data);
 p^.StyleName:=StyleName.text;
 TreeView.Selected.text:=StyleName.text;
 SetModified(True);
end;


procedure TStyleForm.ProcessNodes(node:TTreeNode;Processor:TNodeModify);
var p:PStyleRecord;
    i:integer;
begin
p:=PStyleRecord(node.Data);
if p<>nil then Processor(p);
for i:=0 to node.Count-1 do
 ProcessNodes(node.Item[i],Processor);
end;


procedure TStyleForm.SaveDialogCanClose(Sender: TObject;
  var CanClose: Boolean);
begin
if SaveDialog.FileName<>'' then
appconst.sysinfo.folders.AFMFolder:=ExtractFilePath(SaveDialog.FileName);

end;

end.
