unit opt;
{
(c) . . , . .  1997,2006
}
{$INCLUDE Compmode.inc}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Mask, ToolEdit, checklst, Grids,
  DBGrids, Db, DBCtrls, Dialogs, DBTables, ExtDlgs, RXLookup, DBCGrids,
   Placemnt, RXCalc, Menus, Execfile, RXSpin, ToolWin;

type
  Toptions = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    GroupBox10: TGroupBox;
    ClearHist: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    SavingFreq: TRxSpinEdit;
    HistNum: TRxSpinEdit;
    ExcelTemplates: TTabSheet;
    ToolBar1: TToolBar;
    AddTemplate: TToolButton;
    ChangeTemplate: TToolButton;
    XLSOpen: TOpenDialog;
    TemplateName: TEdit;
    RenameTemplate: TToolButton;
    SaveTemplateAs: TToolButton;
    LoadTemplate: TToolButton;
    XLSSave: TSaveDialog;
    RemoveTemplate: TToolButton;
    UpTemplate: TToolButton;
    DownTemplate: TToolButton;
    XLSMode: TPageControl;
    XLSFile: TTabSheet;
    XLSModel: TTabSheet;
    XLSTemplatesList: TListBox;
    MdlXLSTemplates: TListBox;
    Label7: TLabel;
    ConfirmReport: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure ClearHistClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AddTemplateClick(Sender: TObject);
    procedure ChangeTemplateClick(Sender: TObject);
    procedure RenameTemplateClick(Sender: TObject);
    procedure SaveTemplateAsClick(Sender: TObject);
    procedure LoadTemplateClick(Sender: TObject);
    procedure RemoveTemplateClick(Sender: TObject);
    procedure UpTemplateClick(Sender: TObject);
    procedure DownTemplateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  options: Toptions;

implementation

{$R *.DFM}
uses Main,utils,coloredgrid,fileutil, StrTab, items,
  appConst, Logs,     compops,      dcommon,shellapi,
  itutils,mylists, otherlists,ZLibEx;






procedure Toptions.FormActivate(Sender: TObject);
var i:integer;
begin
for i:=1 to OrgMasterMain.ModelContense.Count do
MdlXLSTemplates.items.clear;
//OrgMasterMain.PicTable.Filter:='SprType=999999';
{St.RestoreProperties;}
If OrgMasterMain.Hist.Strings.Count=0 Then
ClearHist.Enabled:=false
else
ClearHist.Enabled:=true;

xlsModel.TabVisible:=STRTables.modelt.active;
xlsModel.Visible:=STRTables.modelt.active;
MdlXLSTemplates.items.clear;
if xlsModel.Visible then
begin
for i:=1 to OrgMasterMain.modelcontense.Count do
 if OrgMasterMain.modelcontense[i]^.otype=appconst.xlsID then
 begin
  MdlXLSTemplates.Items.AddObject(OrgMasterMain.modelcontense[i]^.name,TObject(OrgMasterMain.modelcontense[i]))
 end;
SortTemplates(MdlXLSTemplates.Items);
XlSMode.ActivePage:=XlsModel;
end
else
XlSMode.ActivePage:=XlsFile;
if not pagecontrol1.ActivePage.TabVisible then pagecontrol1.ActivePage:=pagecontrol1.Pages[0];
end;

procedure Toptions.OKBtnClick(Sender: TObject);
var i,j:integer;
    andmask:integer;
    ni:TStringList;
begin
{St.SaveProperties;}
{$IFNDEF LIGHTVERSION}
{$IFNDEF VIEW}
ni:=TStringList.Create;
try
 for i:=0 to  XLStemplatesList.Items.count-1 do
 begin
  ni.Add(XLStemplatesList.Items[i]+'||'+IntToStr(Integer(XLStemplatesList.Items.Objects[i])));
 end;
ni.SaveToFile('DOTS\EXCEL\templates.ini');
finally
ni.free;
end;
{$ENDIF}
{$ENDIF}
with OrgMasterMain do
 begin

 Hist.Capacity:=StrToInt(ClearSpaces(HistNum.Text))  ;
 HistNumber:=StrToInt(ClearSpaces(HistNum.Text));
 SourceList.Repaint;
 SPView.repaint;
fillmodelpanel(nil);
  end;
end;

procedure Toptions.ClearHistClick(Sender: TObject);
begin
OrgMasterMain.Hist.Clear;
ClearHist.Enabled:=false;
end;






procedure Toptions.FormCreate(Sender: TObject);
begin
PageControl1.activePage:=PageControl1.pages[0];
end;

procedure Toptions.AddTemplateClick(Sender: TObject);
var newfileindex:integer;
    mo:PModelObject;
    fs:TFileStream;
    bs:TBlobStream;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
newfileindex:=1;
if xlsMode.ActivePage=xlsfile then
begin
while fileexists('DOTS\EXCEL\form'+inttostr(newfileindex)+'.xls') do inc(newfileindex);
fileutil.copyFile('DOTS\EXCEL\default.xls','DOTS\EXCEL\form'+inttostr(newfileindex)+'.xls',nil);
XLSTempLatesList.Items.AddObject(TemplateName.text,TObject(newfileindex));
end
else
if xlsMode.ActivePage=xlsmodel then
begin
STRTables.MODELT.Append;
STRTables.MODELTType.AsInteger:=appconst.XLSID;
fs:=TFileStream.Create('DOTS\EXCEL\Default.xls',fmOpenRead);
bs:=TBlobStream.Create(STRTables.MODELTMbData,bmWrite);
ZLibEx.ZCompressStream(fs,bs,zcMax);
bs.free;
fs.free;
STRTables.MODELTSp1.AsInteger:=mdlXLSTemplates.Items.Count;
STRTables.MODELTName.AsString:=TemplateName.text;
STRTables.MODELT.Post;
mo:=OrgMasterMain.appendnewmodelitem;
OrgMasterMain.ismodelmodify:=true;
MdlXlsTemplates.Items.AddObject(TemplateName.text,TObject(mo));
end;
{$ENDIF}
{$ENDIF}
end;
procedure Toptions.ChangeTemplateClick(Sender: TObject);
var fi:integer;
    shelres:integer;
    mo:PModelObject;
    ro:boolean;
    fs:TFileStream;
    bs:TBlobStream;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if xlsMode.ActivePage=xlsfile then
begin
if XLSTemplateslist.itemindex<0 then exit;
fi:=Integer(XLSTemplateslist.Items.Objects[XLSTemplateslist.itemindex]);
ExecuteAndWait(appconst.sysinfo.datadir+'DOTS\EXCEL\form'+inttostr(fi)+'.xls',false);
end
else
if xlsMode.ActivePage=xlsmodel then
begin
if mdlXLSTemplates.itemindex<0 then exit;
mo:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex]);
fi:=mo^.n;
try
 ro:=false;
except
 ro:=true;
end;
if not ro then
begin
try
STRTables.Locate_MdlObj(fi);
fs:=TFileStream.Create(appconst.sysinfo.datadir+'\SYS\temp\temp.xls',fmCreate);
bs:=TBlobStream.Create(STRTables.MODELTMbData,bmRead);
ZLibEx.ZDeCompressStream(Bs,fs);
bs.free;
fs.free;
repaint;
ExecuteAndWait(appconst.sysinfo.datadir+'\SYS\temp\temp.xls',true);
STRTables.MODELT.Edit;
fs:=TFileStream.Create(appconst.sysinfo.datadir+'\SYS\temp\temp.xls',fmOpenRead);
bs:=TBlobStream.Create(STRTables.MODELTMbData,bmWrite);
ZLibEx.ZCompressStream(fs,bs,zcMax);
bs.free;
fs.free;

STRTables.MODELT.Post;
finally
end;
OrgMasterMain.ismodelmodify:=true;
end
else
begin
STRTables.Locate_MdlObj(fi);
fs:=TFileStream.Create(appconst.sysinfo.datadir+'\SYS\temp\temp.xls',fmCreate);
bs:=TBlobStream.Create(STRTables.MODELTMbData,bmRead);
ZLibEx.ZDeCompressStream(Bs,fs);
bs.free;
fs.free;
repaint;
ExecuteAndWait(appconst.sysinfo.datadir+'\SYS\temp\temp.xls',false);
end;
end;
{$ENDIF}
{$ENDIF}
end;

procedure Toptions.RenameTemplateClick(Sender: TObject);
var fi:integer;
    mo:PModelObject;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if xlsMode.ActivePage=xlsfile then
begin
if XLSTempLatesList.ItemIndex>=0 then
XLSTempLatesList.Items[XLSTempLatesList.ItemIndex]:=TemplateName.Text;
end
else
if xlsMode.ActivePage=xlsmodel then
begin
if mdlXLSTempLates.ItemIndex=-1 then exit;
mo:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex]);
fi:=mo^.n;
mdlXLSTempLates.Items[mdlXLSTempLates.ItemIndex]:=TemplateName.Text;
STRTables.Locate_MdlObj(fi);
STRTables.modelT.edit;
STRTables.MODELTName.AsString:=TemplateName.Text;
STRTables.MODELT.Post;
mo^.name:=TemplateName.Text;
OrgMasterMain.ismodelmodify:=true;
end
{$ENDIF}
{$ENDIF}
end;

procedure Toptions.SaveTemplateAsClick(Sender: TObject);
var fi:integer;
    fs:TFileStream;
    bs:TBlobStream;
begin
if xlsMode.ActivePage=xlsfile then
begin
if XLSTempLatesList.ItemIndex>=0 then
 begin
 fi:=Integer(XLSTemplateslist.Items.Objects[XLSTemplateslist.itemindex]);
  XLSSave.FileName:=utils.NormalFileName(XLSTempLatesList.Items[XLSTempLatesList.ItemIndex])+'.xls';
XLSSave.Title:='  '+XLSTempLatesList.Items[XLSTempLatesList.ItemIndex];
  if xlssave.Execute then
  fileutil.CopyFile(appconst.sysinfo.datadir+'\DOTS\EXCEL\form'+inttostr(fi)+'.xls',XLSSave.FileName,nil);
  setcurrentdir(appconst.sysinfo.datadir);
 end;
end
else
if xlsMode.ActivePage=xlsmodel then
begin
if mdlXLSTempLates.ItemIndex>=0 then
 begin
 fi:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex])^.n;
  XLSSave.FileName:=utils.NormalFileName(mdlXLSTempLates.Items[mdlXLSTempLates.ItemIndex])+'.xls';
XLSSave.Title:='  '+mdlXLSTempLates.Items[mdlXLSTempLates.ItemIndex];
  if xlssave.Execute then
  begin
  STRTables.Locate_MdlObj(fi);
fs:=TFileStream.Create(XLSSave.FileName,fmCreate);
bs:=TBlobStream.Create(STRTables.MODELTMbData,bmRead);
ZLibEx.ZDeCompressStream(Bs,fs);
bs.free;
fs.free;

  end;
  setcurrentdir(appconst.sysinfo.datadir);
 end;

end;
end;

procedure Toptions.LoadTemplateClick(Sender: TObject);
var fi:integer;
    mo:PModelObject;
    fs:TFileStream;
    bs:TBlobStream;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if xlsMode.ActivePage=xlsfile then
begin
if XLSTempLatesList.ItemIndex>=0 then
 begin
 fi:=Integer(XLSTemplateslist.Items.Objects[XLSTemplateslist.itemindex]);
XLSOpen.Title:='  '+XLSTemplateslist.Items[XLSTemplateslist.ItemIndex];
  if xlsOpen.Execute then
  fileutil.CopyFile(XlsOpen.filename,appconst.sysinfo.datadir+'\DOTS\EXCEL\form'+inttostr(fi)+'.xls',nil);
  setcurrentdir(appconst.sysinfo.datadir);
 end;
end
else
if xlsMode.ActivePage=xlsmodel then
begin
if mdlXLSTempLates.ItemIndex>=0 then
 begin
 mo:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex]);
 fi:=mo^.n;
XLSOpen.Title:='  '+mdlXLSTemplates.Items[mdlXLSTemplates.ItemIndex];
  if xlsopen.Execute then
  begin
 try
  STRTables.Locate_MdlObj(fi);
  STRTables.MODELT.Edit;
  fs:=TFileStream.Create(XlsOpen.filename,fmOpenRead);
  bs:=TBlobStream.Create(STRTables.MODELTMbData,bmWrite);
   ZLibEx.ZCompressStream(fs,bs,zcMax);
  bs.free;
  fs.free;

  STRTables.MODELT.Post;
  OrgMasterMain.ismodelmodify:=true;
  finally
  end;
  end;
  setcurrentdir(appconst.sysinfo.datadir);
 end;

end;
{$ENDIF}
{$ENDIF}
end;

procedure Toptions.RemoveTemplateClick(Sender: TObject);
var fi,i:integer;
    mo:PModelObject;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if xlsMode.ActivePage=xlsfile then
begin
if XLSTempLatesList.ItemIndex>=0 then
 begin
 fi:=Integer(XLSTemplateslist.Items.Objects[XLSTemplateslist.itemindex]);
 if messagedlg('    :'+XLSTemplateslist.Items[XLSTemplateslist.itemindex],
               mtconfirmation,[mbyes,mbNo],0)=mrYes then
 begin
  fileutil.DeleteFiles(appconst.sysinfo.datadir+'\DOTS\EXCEL\form'+inttostr(fi)+'.xls');
  XLSTemplateslist.Items.Delete(XLSTemplateslist.itemindex);
 end;
 end;
end
else
if xlsMode.ActivePage=xlsmodel then
begin
if MdlXLSTempLates.ItemIndex>=0 then
 begin
 fi:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex])^.n;
  if messagedlg('    :'+MdlXLSTemplates.Items[MdlXLSTemplates.itemindex],
               mtconfirmation,[mbyes,mbNo],0)=mrYes then
 begin
 STRTables.Locate_MdlObj(fi);
 STRTables.MODELT.Edit;
 STRTables.MODELTType.AsInteger:=$FF;
 STRTables.MODELT.Post;
 OrgMasterMain.modelcontense.FreeObjectID(fi);
 for i:=1 to OrgMasterMain.modelcontense.Count do
 if (OrgMasterMain.modelcontense[i]^.otype=appconst.XLSID)and(OrgMasterMain.modelcontense[i]^.sp1>mo^.sp1) then
 begin
  OrgMasterMain.modelcontense[i]^.sp1:=OrgMasterMain.modelcontense[i]^.sp1-1;
  STRTables.Locate_MdlObj(OrgMasterMain.modelcontense[i]^.n);
  STRTables.MODELT.Edit;
  STRTables.MODELTSp1.AsInteger:=OrgMasterMain.modelcontense[i]^.sp1;
  STRTables.MODELT.Post;
 end;
 mdlXLSTemplates.Items.Delete(MdlXLSTemplates.itemindex);
 OrgMasterMain.ismodelmodify:=true;
 end;
 end;
end;
{$ENDIF}
{$ENDIF}
end;

procedure Toptions.UpTemplateClick(Sender: TObject);
var fi1,fi2:integer;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if xlsMode.ActivePage=xlsfile then
begin
if XLSTempLatesList.ItemIndex>0 then
XLSTemplatesList.items.Exchange(XLSTempLatesList.ItemIndex,XLSTempLatesList.ItemIndex-1);
end
else
if xlsMode.ActivePage=xlsmodel then
begin
if mdlXLSTempLates.ItemIndex<=0 then exit;
fi1:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex])^.n;
fi2:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex-1])^.n;
STRTables.Locate_MdlObj(fi1);
STRTables.MODELT.Edit;
STRTables.MODELTSp1.AsInteger:=mdlXLSTemplates.itemindex-1;
STRTables.MODELT.Post;
OrgMasterMain.modelcontense.getModelObjectByID(fi1)^.sp1:=mdlXLSTemplates.itemindex-1;
STRTables.Locate_MdlObj(fi2);
STRTables.MODELT.Edit;
STRTables.MODELTSp1.AsInteger:=mdlXLSTemplates.itemindex;
STRTables.MODELT.Post;
OrgMasterMain.modelcontense.getModelObjectByID(fi2)^.sp1:=mdlXLSTemplates.itemindex;
mdlXLSTemplates.items.Exchange(mdlXLSTempLates.ItemIndex,mdlXLSTempLates.ItemIndex-1);
OrgMasterMain.ismodelmodify:=true;
end;
{$ENDIF}
{$ENDIF}
end;

procedure Toptions.DownTemplateClick(Sender: TObject);
var fi1,fi2:integer;
begin
{$IFNDEF VIEW}
{$IFNDEF LIGHTVERSION}
if xlsMode.ActivePage=xlsfile then
begin
if (XLSTempLatesList.ItemIndex>=0)and(XLSTempLatesList.ItemIndex<XLSTempLatesList.items.Count-1) then
XLSTemplatesList.items.Exchange(XLSTempLatesList.ItemIndex,XLSTempLatesList.ItemIndex+1);
end
else
if xlsMode.ActivePage=xlsmodel then
begin
if (mdlXLSTempLates.ItemIndex<0)or(mdlXLSTempLates.ItemIndex>=mdlXLSTempLates.items.Count-1) then exit;
fi1:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex])^.n;
fi2:=PModelObject(mdlXLSTemplates.Items.Objects[mdlXLSTemplates.itemindex+1])^.n;
STRTables.Locate_MdlObj(fi1);
STRTables.MODELT.Edit;
STRTables.MODELTSp1.AsInteger:=mdlXLSTemplates.itemindex+1;
STRTables.MODELT.Post;
OrgMasterMain.modelcontense.getModelObjectByID(fi1)^.sp1:=mdlXLSTemplates.itemindex+1;
STRTables.Locate_MdlObj(fi2);
STRTables.MODELT.Edit;
STRTables.MODELTSp1.AsInteger:=mdlXLSTemplates.itemindex;
STRTables.MODELT.Post;
OrgMasterMain.modelcontense.getModelObjectByID(fi2)^.sp1:=mdlXLSTemplates.itemindex;
mdlXLSTemplates.items.Exchange(mdlXLSTempLates.ItemIndex,mdlXLSTempLates.ItemIndex+1);
OrgMasterMain.ismodelmodify:=true;
end;
{$ENDIF}
{$ENDIF}
end;

end.
